; wallx v1.81x - ejn (blueznl)
; pb5.30
; bluez@xs4all.nl
;
; - wallpaper loader
;
#program_version = "v1.81"
#program_copyright = "c2010..2016 EJN"
;
InitNetwork()
UseJPEGImageDecoder()
UsePNGImageDecoder()
EnableExplicit
IncludeFile("..\x_lib\x_lib.pb")
Declare init()
Declare main()
x_init()
init()
main()
End

Procedure history()
  ;
  ; planned
  ;
  ; - dunno
  ;
  ; v1.81x
  ;
  ; - added support for .PNG and .BMP files
  ;
  ; v1.80
  ;
  ; - minor changes due to different handling of included data and localisation of labels
  ; - could sometimes miss one or more ip addresses, fixed
  ;
  ; v1.75x
  ;
  ; - fixed shown preset
  ; - fixed a bug with 'set'
  ; - improved path detection in generated commandlines
  ; - improved shortcut naming
  ; - led To indicate existence of autorun entry
  ; - updated documentation
  ; - modified behaviour when exiting gui
  ; - renamed 'resident' to 'background'
  ;
  ; v1.70x
  ;
  ; - a new gui
  ; - new 'invert' effect
  ; - full rewrite of internal command handling
  ; - added 'load image' without the 'load' command
  ; - so drag / drop of an image file on the wallx exe works now
  ; - desktop shortcut creation
  ; - create autorun option
  ; - expanded help text
  ; - more bugs! (thoug none that I am aware of :-))
  ;
  ; v1.63x
  ;
  ; - compiled with 4.61 beta 1
  ; - figured out some Windows 7 issues, updated docs
  ; - added a batch file and an image, updated help text
  ; - added 'tempfolder'
  ; - 'save' now sets 'keep' as well
  ; - added 'dotmark', 'darkmark', "wallmark"
  ; - added 'adminmark'
  ; - added 'blur' and 'darken'
  ; - added 'orange'
  ; - changed 'mark'
  ;
  ; v1.51x
  ;
  ; - improved (?) detection of ip changes
  ; - now handles no ethernet adapters (sony vaio without a pcmcia network adapter)
  ;
  ; v1.49x
  ;
  ; - forced screen update after 5 minute period without any messages (hibernation detection)
  ; - should (not fully explored yet) now be able to handle multiple ip adresses and show the last changed address
  ;
  ; v1.44x
  ;
  ; - bigfix, should no longer crash when using wallx.lst
  ; - using new version of x_lib
  ;
  ; v1.42x
  ;
  ; - changed path options, they were confusing
  ; - replaced 'current' with 'frompanel'
  ; - replaced 'random nearby' with 'random programfolder'
  ; - added 'random currentfolder'
  ;
  ; v1.40x
  ;
  ; - reversed all changes since 1.37x
  ; - added 'keep'
  ; - added 'current'
  ; - added 'pairs'
  ; - much improved documentation (help file)
  ;
  ; v1.36
  ;
  ; - added ~user~
  ; - added ~USER~
  ; - added ~HOST~
  ;
  ; v1.33
  ;
  ; - added 'renew'
  ; - added 'nouser'
  ;
  ; v1.32
  ;
  ; - bugfix 'silent'
  ; - fixed some typos
  ; - added batch file example for dropping image files
  ;
  ; v1.30
  ;
  ; - fixed a bug in selecting entry from wallx.lst
  ; - adding 'wrap around' step to handle windows' stupid wallpaper wrap
  ; - added 'frame' parameter (good for screenshots and debugging)
  ;
  ; v1.28x
  ;
  ; - 'random' now allows a path 'nearby'
  ;
  ; v1.26x
  ;
  ; - 'big' now bases fontsize on monitor size
  ; - added alerts to report missing files and unrecognized commands
  ; - added 'silent' parameter to silence the new alerts ;-)
  ;
  ; v1.22x
  ;
  ; - new 'random' keyword to load random file(s) from folder
  ; - recognizes wallx.lst file
  ; - transparent mode for superimposed text
  ; - added distort and expand commands
  ; - added transparent command
  ;
  ; v1.18x
  ;
  ; - added support for individual per monitor settings
  ; - improved load command, autodetects multi monitor wallpapers and auto adjusts images
  ;
  ; v1.17
  ;
  ; - upgraded to pb4.40b7
  ; - added registry routine as I 'tiling' to handle multi monitor setup
  ; - changed screen change detection for multi monitor support
  ;
  ; v1.16
  ;
  ; - figured out issues with vista (64) and gave up on it...
  ; - added better support for windows 98
  ; - fixed background on multiple lines of text
  ; - denies background changes by other programs when running resident (might help in vista)
  ;
  ; v1.07
  ;
  ; - restructured command line processing
  ; - improved littlehelp() routine
  ; - added 'real' command line processing (to be included in future x_lib's)
  ; - added reading from a configuration file
  ; - text command now allows empty lines
  ; - real time monitoring enabled
  ; - little 'lazyhelp' viewer included
  ;
  ; v1.00
  ;
  ; - had to turn this into a real program, as it was getting a little unmanageable :-)
  ;
  ; v0.08x
  ;
  ; - ah, something that works!
  ;
EndProcedure

Procedure init()
  ;
  ; *** gui elements
  ;
  ;
  Enumeration
    ;
    #w_main_nr
    ;
    #g_preset_t
    #g_preset
    ;
    #g_try
    #g_auto
    ;
    #g_frame
    #g_background_t
    #g_background
    ;
    #g_background_file_t
    #g_background_file
    #g_background_browse
    #g_effect1_t
    #g_effect1_dots
    #g_effect1_fade
    #g_effect1_darken
    #g_effect1_drain
    #g_effect1_invert
    #g_effect1_blur
    #g_big_text_t
    #g_big_text
    #g_big_transparent
    #g_big_reverse
    #g_effect2_t
    #g_effect2_dots
    #g_effect2_fade
    #g_effect2_darken
    #g_effect2_drain
    #g_effect2_invert
    #g_effect2_blur
    #g_normal_text_t
    #g_normal_text
    #g_normal_transparent_t
    #g_normal_transparent
    #g_normal_reverse
    #g_effect3_t
    #g_effect3_dots
    #g_effect3_fade
    #g_effect3_darken
    #g_effect3_drain
    #g_effect3_invert
    #g_effect3_blur
    ;
    #g_timeandplace_t
    #g_distort_t
    #g_distort
    #g_expand_t
    #g_expand
    #g_renew_t
    #g_renew
    #g_nouser_t
    #g_nouser
    ;
    #g_system_t
    #g_keep
    #g_resident
    ;
    #g_commandline_t
    #g_commandline
    ;
    #g_autorun_led
    #g_autorun_set
    #g_autorun_clear
    #g_shortcut
    #g_copy
    #g_exit
    #g_help
    ;
  EndEnumeration
  ;
  ; *** combobox dropdown lists
  ;
  Enumeration
    #g_preset__none
    #g_preset__default
    #g_preset__autorun
    #g_preset__poweruser
    #g_preset__pinktimestamp
    #g_preset__adminmark
    #g_preset__basemark
    #g_preset__drainedbase
    #g_preset__doubleinvert
    #g_preset__loadfile
    #g_preset__randomfrompath
    #g_preset__randomfromprogramfolder
    #g_preset__directorscut
    #g_preset__autochange
    #g_preset__frame
    #g_preset__unwise
  EndEnumeration
  Enumeration
    #g_background__randomcolour
    #g_background__red
    #g_background__green
    #g_background__blue
    #g_background__cyan
    #g_background__lime
    #g_background__orange
    #g_background__pink
    #g_background__black
    #g_background__grey
    #g_background__white
    #g_background__traffic
    #g_background__base
    #g_background__frame
    #g_background__file
    #g_background__path
    #g_background__programfolder
  EndEnumeration
  ;
  Global w_main_h.i
  ;
  ; *** images
  ;
  Enumeration
    ;
    #i_0
    #i_1
    #i_2
    #i_3
    ;
    #i_led_white_1
    #i_led_green_1
    #i_eyes_2
    #i_eyes_3
    #i_windows
    #i_windows_grey
    #i_copy
    #i_help
    #i_exit
    #i_shortcut
    ;
  EndEnumeration
  ;
  DataSection
    ;
    i_led_white_1:
    IncludeBinary("icons\led_white_1.ico")
    i_led_green_1:
    IncludeBinary("icons\led_green_1.ico")
    i_eyes_2:
    IncludeBinary("icons\eyes_2.ico")
    i_eyes_3:
    IncludeBinary("icons\eyes_3.ico")
    i_copy:
    IncludeBinary("icons\copy.ico")
    i_help:
    IncludeBinary("icons\help.ico")
    i_shortcut:
    IncludeBinary("icons\shortcut.ico")
    i_windows_xp:
    IncludeBinary("icons\windows_xp.ico")
    i_windows_grey:
    IncludeBinary("icons\windows_grey.ico")
    i_exit:
    IncludeBinary("icons\exit.ico")
    ;
  EndDataSection
  ;
  Global i_led_white_h     = CatchImage(#i_led_white_1,  ?i_led_white_1)
  Global i_led_green_h     = CatchImage(#i_led_green_1,  ?i_led_green_1)
  Global i_eyes_2_h        = CatchImage(#i_eyes_2,       ?i_eyes_2)
  Global i_eyes_3_h        = CatchImage(#i_eyes_3,       ?i_eyes_3)
  Global i_copy_h          = CatchImage(#i_copy,         ?i_copy)
  Global i_help_h          = CatchImage(#i_help,         ?i_help)
  Global i_exit_h          = CatchImage(#i_exit,         ?i_exit)
  Global i_shortcut_h      = CatchImage(#i_shortcut,     ?i_shortcut)
  Global i_windows_h       = CatchImage(#i_windows,      ?i_windows_xp)
  Global i_windows_grey_h  = CatchImage(#i_windows_grey, ?i_windows_grey)
  ;
  ;
  ; *** variables / command line parameters
  ;
  Global helptext.s                                              ; text to show for help function
  Global wall_filename.s = GetTemporaryDirectory()+"wallx.bmp"   ; temporary filename used for creating the background
  Global fontname.s = "Arial"                                    ; default font (name)
  Global fontsize.i = 64                                         ; default font (size)
  Global fontcolor = $FFFFFF                                     ; default font (color)
  Global stayresident.i = #False                                 ; stay alive and monitor IP or screen changes
  Global keep.i = #False                                         ; set cpanel, do not remove temp
  Global pairs.i = 20                                            ; default percentage for using wallx.lst pairs
  Global killmessage.s = "wallx - terminate"                     ; message used to kill wallx instances
  Global killmessage_nr.i = RegisterWindowMessage_(@killmessage) ; registered message number for the kill message
  ;
  Global desktops_n.i                                            ; number of desktops (monitors)
  Global wallpaper_x.i, wallpaper_y.i                            ; wallpaper origion (top leftmost screen corner)
  Global wallpaper_width.i, wallpaper_height.i                   ; total desktops width and height
  Global wallpaper_aspect.f
  Global aspect_distort.i = 15                                   ; image may be distorted up to 15% (half that for single screen images)
  Global multi_expand.i = 53                                     ; image may be expanded up to for multi monitor setups 53%
  Global transparent.i = #False                                  ; draw text in transparent mode (default off)
  Global silent.i = #False                                       ; alert on missing files and wrong commands (default on)
  Global renew.i = 0                                             ; refresh wallpaper after n seconds, 0 is no refresh (default 0)
  Global renew_counter.i = 0                                     ; number of ticks since last refresh
  Global freeze_counter.i = 0                                    ; number of ticks since previous event
  Global nouser.i = 120                                          ; only refresh if there is no user activity (default 2 minutes)
  ;
  Global Dim ipaddress.i(20)                                     ; array with all ip adresses
  Global ipaddress_n.i                                           ; nr of entries
  Global old_ipaddress_n.i                                       ; old nr of entries
  Global ipaddress_now.i                                         ; current ip adress (best guess :-))
  ;
  ;
  ; *** desktop / area information used to build the background map
  ;
  Structure desktop
    x.i                                                          ; x coordinate of desktop
    y.i                                                          ; y coordinate of desktop
    width.i                                                      ; width of desktop
    height.i                                                     ; height of desktop
    depth.i                                                      ; colour depth
  EndStructure
  ;
  ;  Structure LASTINPUTINFO                                     ; structure for detection of user activity
  ;    cbSize.l
  ;    dwTime.l
  ;  EndStructure
  ;
  Global Dim desktop.desktop(10)                                 ; create an array for 10 screens, that should do it :-)
  ;
  Global area_selected.i = -1                                    ; selected area aka desktop aka monitor (-1 means all)
  Global area_n.i                                                ; desktop for which output is prepared (mostly used as a loop counter)
  Global area_first.i, area_last.i                               ; first and last desktop to draw on (simplifies per desktop vs. for all code)
  Global area_x.i, area_y.i                                      ; x,y of the area of the big generated wallpaper related to the specified monitor
  Global area_width.i, area_height.i                             ; width / height
  Global area_aspect.f                                           ; aspect ratio
  ;
  DataSection
    helptext:
    IncludeBinary("wallx.txt")
    Data.b 0, 0
  EndDataSection
  Global p_helptext = ?helptext
  ;
  ;
  ; *** event handling
  ;
  Global event.i, event_window.i, event_gadget.i, event_menu.i   ; variables for event handling
  ;
  ;
  ; *** other
  ;
  Global preset.i                                                ; stores the kind of profile used upon launch of the GUI
  Global commandline.s                                           ; (generated or retrieved) commandline
  Global command_n.i                                             ; number of commands in the commandline string
  Global gui.i                                                   ; flag that indicates a gui is used instead of a hidden window
  Global command_error.i                                         ; indicates a command or parameter was unrecognized
  ;
EndProcedure

Procedure.s maketext(text.s)
  Protected n.i, x.s
  ;
  ; *** replaces placeholders with actual information
  ;
  ; replace eventual placeholders such as ~ip~
  ;
  text = ReplaceString(text,"~user~",GetEnvironmentVariable("USERNAME"))
  text = ReplaceString(text,"~ip~",IPString(ipaddress_now))
  text = ReplaceString(text,"~host~",Hostname())
  text = ReplaceString(text,"~timestamp~",FormatDate("%dd/%mm/%yy %hh:%ii:%ss",Date()))
  text = ReplaceString(text,"~desktop~",Str(area_n+1))
  text = ReplaceString(text,"~monitor~",Str(area_n+1))
  ;
  text = ReplaceString(text,"~USER~",UCase((GetEnvironmentVariable("USERNAME"))))
  text = ReplaceString(text,"~HOST~",UCase(Hostname()))
  ;
  If FindString(text,"~ipall~") > 0
    n = 0
    x = ""
    While n < ipaddress_n
      n = n+1
      x = x+IPString(ipaddress(n))+" "
    Wend
    text = ReplaceString(text,"~ipall~",Trim(x))
  EndIf
  
  ProcedureReturn text.s
  ;
EndProcedure

Procedure.i checkdesktops()
  Protected change.i, nn.i
  ;
  ; *** check for desktop changes
  ;
  ; retval: #true    - desktop has changed since last check
  ;         #false   - no change since last check
  ;
  ; get information on all desktops and report if there were changes
  ;
  wallpaper_x = 0
  wallpaper_y = 0
  wallpaper_width = 0
  wallpaper_height = 0
  ;
  change.i = #False
  If ExamineDesktops() <> desktops_n
    change = #True
    desktops_n = ExamineDesktops()
  EndIf
  ;
  wallpaper_x = 0
  wallpaper_y = 0
  wallpaper_width = 0
  wallpaper_height = 0
  ;
  nn = 0
  While nn < desktops_n
    If desktop(nn)\depth <> DesktopDepth(nn) Or desktop(nn)\x <> x_desktopx(nn) Or desktop(nn)\y <> x_desktopy(nn) Or desktop(nn)\width <> DesktopWidth(nn) Or desktop(nn)\height <> DesktopHeight(nn)
      desktop(nn)\x = DesktopX(nn)
      desktop(nn)\y = DesktopY(nn)
      desktop(nn)\width = DesktopWidth(nn)
      desktop(nn)\height = DesktopHeight(nn)
      desktop(nn)\depth = DesktopDepth(nn)
      change = #True
    EndIf
    ;
    wallpaper_x = x_min(wallpaper_x,x_desktopx(nn))
    wallpaper_y = x_min(wallpaper_y,x_desktopy(nn))
    wallpaper_width = x_max(wallpaper_width,x_desktopx(nn)+DesktopWidth(nn))
    wallpaper_height = x_max(wallpaper_height,x_desktopy(nn)+DesktopHeight(nn))
    ;
    nn = nn+1
  Wend
  ;
  wallpaper_width = wallpaper_width-wallpaper_x
  wallpaper_height = wallpaper_height-wallpaper_y
  ;
  ProcedureReturn change
EndProcedure

Procedure.i checkipadresses()
  Protected ipaddress_test.i, change.i
  ;
  ExamineIPAddresses()
  ipaddress_test = NextIPAddress()
  ipaddress_now = ipaddress_test
  ;
  ipaddress_n = 0
  While ipaddress_test <> 0 And ipaddress_n < 20
    ipaddress_n = ipaddress_n+1
    If ipaddress_test <> ipaddress(ipaddress_n)
      ipaddress(ipaddress_n) = ipaddress_test
      If ipaddress_test <> 0
        ipaddress_now = ipaddress_test
      EndIf
      change = #True
    EndIf
    If ipaddress_now = 0
      ipaddress_now = ipaddress_test
    EndIf
    ipaddress_test = NextIPAddress()
  Wend
  If ipaddress_n <> old_ipaddress_n
    old_ipaddress_n = ipaddress_n
    change = #True
  EndIf
  ;
  ProcedureReturn change
EndProcedure

Procedure getdesktopposition(n)
  ;
  ; *** get boundaries (position, size) of monitor to set output to
  ;
  ; ah... shades of the old purebasic usewhatever commands :-)
  ;
  ; there seems to be some inconsistensies inside windows regarding desktop wallpapers
  ; when dealing with multi monitor setups with different screen sizes , this should
  ; fix it
  ;
  If n < 0 Or n >= desktops_n
    n = 0
  EndIf
  If n = -1
    area_x = 0
    area_y = 0
    area_width = wallpaper_width
    area_height = wallpaper_height
  Else
    area_x = desktop(n)\x-wallpaper_x
    area_y = desktop(n)\y-wallpaper_y
    area_width = desktop(n)\width
    area_height = desktop(n)\height
  EndIf
  area_aspect = area_width / area_height
  ;
EndProcedure

Procedure loadfile(file.s)
  Protected image_aspect.f, cut_height.i, cut_width.i, cut_x.i, cut_y.i, retval.i
  Global mode.i
  ;
  ; *** load a wallpaper
  ;
  ; - if the aspect ratio differs too much the image is cropped
  ; - for single screen images only half the distortion of multi screen images is accepted
  ; - automatically detect and apply multi monitor images
  ;
  ; global aspect_distort.i defines the amount of distortion in %
  ; global multi_expend.i defines the amount of expension for multi monitor setups in %
  ;
  If LoadImage(2,file) = 0
    ;
    If silent
    Else
      MessageRequester("WallX "+#program_version,"Missing image file"+#CRLF$+#CRLF$+file,#PB_MessageRequester_Ok|#MB_ICONERROR)
    EndIf
    ;
  Else
    ;
    wallpaper_aspect = wallpaper_width / wallpaper_height
    image_aspect = ImageWidth(2)/ImageHeight(2)
    ;
    If wallpaper_aspect*115 > image_aspect*(100-aspect_distort) And wallpaper_aspect*(100-aspect_distort)< image_aspect*115 And ImageWidth(2)*100 > wallpaper_width*(100-multi_expand) And ImageHeight(2)*100 > wallpaper_height*(100-multi_expand)
      ;
      ; aspect ratio is more or less matching the wallpaper aka combined desktops
      ; and we think there's enough detail so let's build it
      ;
      ; can we stretch it at once? (ie. allow a little distortion but no need to clip things)
      ;
      If wallpaper_aspect*100 > image_aspect*(100-aspect_distort) And wallpaper_aspect*(100-aspect_distort) < image_aspect*100
        ;
        ; aspect rations match sufficiently, stretch to cover all desktops
        ;
        StartDrawing(ImageOutput(#i_1))
          DrawImage(ImageID(#i_2),0,0,wallpaper_width,wallpaper_height)
        StopDrawing()
        ;
      Else
        ;
        ; aspect rations differ too much, crop the image
        ;
        If wallpaper_aspect > image_aspect
          cut_width = ImageWidth(2)
          cut_height = x_min( ImageHeight(2) , ImageWidth(2) / wallpaper_aspect * 100 / (100-aspect_distort) )
          cut_x = 0
          cut_y = (ImageHeight(2)-cut_height)/2
        Else
          cut_height = ImageHeight(2)
          cut_width = x_min( ImageWidth(2) , ImageHeight(2) * wallpaper_aspect * 100 / (100-aspect_distort) )
          cut_x = (ImageWidth(2)-cut_width)/2
          cut_y = 0
        EndIf
        StartDrawing(ImageOutput(#i_2))
          GrabDrawingImage(#i_3,cut_x,cut_y,cut_width,cut_height)
        StopDrawing()
        StartDrawing(ImageOutput(#i_1))
          DrawImage(ImageID(#i_3),0,0,wallpaper_width,wallpaper_height)
        StopDrawing()
        FreeImage(#i_3)
        ;
      EndIf
      ;
    Else
      ;
      ; loaded image wasn't suitable for the multi monitor setup, so let's place it on all selected desktops
      ;
      For area_n = area_first To area_last
        getdesktopposition(area_n)
        ;
        If area_aspect*100 > image_aspect*(100-aspect_distort/2) And area_aspect*(100-aspect_distort/2) < image_aspect*100
          ;
          ; aspect rations match sufficiently, stretch to cover selected desktop
          ; note: distortion ratio accepted for single screens is half that of multi monitor setups
          ; (arbitrary decision, I admit :-))
          ;
          StartDrawing(ImageOutput(#i_1))
            DrawImage(ImageID(#i_2),area_x,area_y,area_width,area_height)
          StopDrawing()
          ;
        Else
          ;
          ; aspect rations differ too much, crop the image
          ;
          If wallpaper_aspect > image_aspect
            cut_width = ImageWidth(2)
            cut_height = x_min( ImageHeight(2) , ImageWidth(2) / area_aspect * 100 / (100-aspect_distort/2) )
            cut_x = 0
            cut_y = (ImageHeight(2)-cut_height)/2
          Else
            cut_height = ImageHeight(2)
            cut_width = x_min( ImageWidth(2) , ImageHeight(2) * area_aspect * 100 / (100-aspect_distort/2) )
            cut_x = (ImageWidth(2)-cut_width)/2
            cut_y = 0
          EndIf
          StartDrawing(ImageOutput(#i_2))
            GrabDrawingImage(#i_3,cut_x,cut_y,cut_width,cut_height)
          StopDrawing()
          StartDrawing(ImageOutput(#i_1))
            DrawImage(ImageID(#i_3),area_x,area_y,area_width,area_height)
          StopDrawing()
          FreeImage(#i_3)
          ;
        EndIf
        ;
      Next
      ;
    EndIf
    FreeImage(#i_2)
    ;
  EndIf
  ;
EndProcedure

Procedure loadrandom(path.s)
  Protected NewList file.s(), x.s, n.i, file.s, p.i, f.s
  ;
  ; *** load one or more wallpapers from the specified folder
  ;
  ; - multi monitor wallpapers will show up with a higher frequency
  ; - this could be compensated by adding pairs in wallx.lst
  ;
  If path = "currentfolder"
    path = GetCurrentDirectory()
  ElseIf path = "programfolder"
    path = GetPathPart(ProgramFilename())
  ElseIf path = "tempfolder"
    path = GetTemporaryDirectory()
  EndIf
  ;
  If Right(path,1) <> "\"
    path = path+"\"
  EndIf
  ;
  ; either load a pair listed in wallx.lst or pick a random file
  ;
  file = path+"wallx.lst"
  If FileSize(file)>2 And Random(100) < pairs
    ;
    ; take an entry from the wallx.lst file (default chance 80%)
    ;
    ClearList(file())
    ReadFile(1,file)
    While Not Eof(1)
      x = Trim(ReadString(1))
      If Left(x,1) <> ";" And x > "" And FindString(x,",",1) > 0
        For n = 1 To 8
          AddElement(file())
          file() = StringField(x,n,",")
        Next
      EndIf
    Wend
    CloseFile(1)
    ;
    p = Random((ListSize(file())-1)/8)*8
    For n = 0 To desktops_n-1
      area_first = n
      area_last = n
      SelectElement(file(),p+n)
      loadfile(path+Trim(file()))
    Next
    ;
  Else
    ;
    ; take a random pick from the specified folder (default chance 80%)
    ;
    If ExamineDirectory(1,path,"*.*") > 0
      While NextDirectoryEntry(1)
        If DirectoryEntryType(1) = #PB_DirectoryEntry_File
          f = Trim(LCase(DirectoryEntryName(1)))
          If Len(f) > 4 And ( Right(f,4) = ".png" Or Right(f,4) = ".jpg" Or Right(f,4) = ".bmp" )
            AddElement(file())
            file() = f
          EndIf
        EndIf
      Wend
      FinishDirectory(1)
    EndIf
    If ListSize(file()) = 0
    Else
      For n = 0 To desktops_n-1
        area_first = n
        area_last = n
        SelectElement(file(),Random(ListSize(file())-1))
        loadfile(path+file())
      Next
    EndIf
    ;
  EndIf
  ;
EndProcedure

Procedure executecommands()
  Protected color.i, x.i, y.i, xx.i, yy.i, n.i, c.i
  Protected t.s, tt.s, nn.i, p.i
  Protected wall_current.s
  Protected command.s, parameter.s
  ;
  ; *** process list of commands
  ;
  silent = #False
  transparent = #False
  fontcolor = $FFFFFF
  ;
  command_error = #False
  command_n = x_commandcount(commandline)
  ;
  If command_n > 0
    ;
    ; create image
    ;
    CreateImage(#i_1,wallpaper_width,wallpaper_height,24)
    StartDrawing(ImageOutput(#i_1))
      FrontColor(RGB(64+Random(64),64+Random(64),64+Random(64)))
      Box(0,0,wallpaper_width,wallpaper_height)
    StopDrawing()
    ;
    ; default desktop stuff
    ;
    area_selected = -1
    area_first = 0
    area_last = desktops_n-1
    getdesktopposition(-1)
    ;
    ; go through all commands in the list
    ;
    p = 1
    Repeat
      ;
      If area_selected = -1
        area_first = 0
        area_last = desktops_n-1
      Else
        area_first = area_selected
        area_last = area_selected
      EndIf
      ;
      command = x_commandfield(commandline,p)
      parameter = x_commandfield(commandline,p+1)
      ;
      Select x_commandfield(commandline,p)
          Case ""
            ;
            ; nothing, last entry, whatever, just skip
            ;
            p = p+1
            ;
          Case "silent"
            ;
            ; skip alerts on missing files and other problems
            ;
            silent = #True
            p = p+1
            ;
          Case "distort"
            ;
            ; set maximal distortion for multi monitor images
            ; image is stretched to specified limit, above that it is cropped
            ;
            aspect_distort = Val(parameter)
            p = p+2
            ;
          Case "expand"
            ;
            ; maximal expansion (resize) of suitable multi monitor wallpapers with a (too) low resolution
            ;
            multi_expand = Val(parameter)
            p = p+2
            ;
          Case "transparent"
            ;
            ; all subsequent superimposed text will be transparent
            ;
            transparent =  #True
            p = p+1
            ;
          Case "solid"
            ;
            transparent = #False
            p = p+1
            ;
          Case "desktop", "monitor"
            ;
            ; selected desktop aka monitor to send output to, 'all' for all
            ;
            If parameter = "all"
              area_selected = -1
              area_first = 0
              area_last = desktops_n-1
            Else
              area_selected = Val(parameter)
              area_first = area_selected
              area_last = area_selected
            EndIf
            getdesktopposition(area_selected)
            p = p+2
            ;
          Case "frame"
            ;
            For area_n = 0 To desktops_n
              getdesktopposition(area_n)
              StartDrawing(ImageOutput(#i_1))
                DrawingMode(#PB_2DDrawing_Default)
                For x = area_x To area_x+area_width-4 Step 4
                  FrontColor(RGB($FF,$FF,$FF))
                  Box(x,area_y,2,2)
                  Box(x,area_y+area_height-2,2,2)
                  FrontColor(RGB($00,$00,$00))
                  Box(x+2,area_y,2,2)
                  Box(x+2,area_y+area_height-2,2,2)
                Next
                For y = area_y To area_y+area_height-4 Step 4
                  FrontColor(RGB($FF,$FF,$FF))
                  Box(area_x,y,2,2)
                  Box(area_x+area_width-2,y,2,2)
                  FrontColor(RGB($00,$00,$00))
                  Box(area_x,y+2,2,2)
                  Box(area_x+area_width-2,y+2,2,2)
                Next
              StopDrawing()
            Next
            p = p+1
            ;
          Case "red" , "green" , "blue" , "pink" , "lime" , "black" , "white" , "grey", "brown", "cyan", "orange"
            ;
            ; one colour full-screen, per monitor
            ;
            For area_n = area_first To area_last
              getdesktopposition(area_n)
              StartDrawing(ImageOutput(#i_1))
                DrawingMode(#PB_2DDrawing_Default)
                Select command
                    Case "red"
                      FrontColor(RGB($7F,$00,$00))         ; 50% red
                    Case "green"
                      FrontColor(RGB($00,$7F,$00))         ; 50% green
                    Case "blue"
                      FrontColor(RGB($00,$00,$7F))         ; 50% blue
                    Case "black"
                      FrontColor(0)                        ; full black
                    Case "white"
                      FrontColor($FFFFFF)                  ; full white
                    Case "grey"
                      FrontColor($3F3F3F)                  ; 25% grey
                    Case "cyan"
                      FrontColor(RGB($00,$FF,$FF))         ; typical cyan
                    Case "brown"
                      FrontColor(RGB($80,$40,$00))         ; typical brown
                    Case "pink"
                      FrontColor(RGB($E0,$20,$60))         ; an awful pink :-)
                    Case "lime"
                      FrontColor(RGB($A0,$F0,$00))         ; another awful colour :-)
                    Case "orange"
                      FrontColor(RGB($FF,$80,$00))         ; hard orange
                EndSelect
                Box(area_x,area_y,area_width,area_height)
              StopDrawing()
            Next
            p = p+1
            ;
          Case "color"
            ;
            ; use spedified colour, per monitor
            ;
            t = parameter
            If Len(t) = 7
              t = Right(t,6)
            EndIf
            If Len(t) = 6
              color = RGB(Val("$"+Mid(t,1,2)),Val("$"+Mid(t,3,2)),Val("$"+Mid(t,5,2)))
              For area_n = area_first To area_last
                getdesktopposition(area_n)
                ;
                StartDrawing(ImageOutput(#i_1))
                  DrawingMode(#PB_2DDrawing_Default)
                  FrontColor(color)
                  Box(area_x,area_y,area_width,area_height)
                StopDrawing()
              Next
            EndIf
            p = p+2
            ;
          Case "base"
            ;
            ; yellow diagonals on black background, all monitors
            ;
            StartDrawing(ImageOutput(#i_1))
              DrawingMode(#PB_2DDrawing_Default)
              Box(0,0,wallpaper_width,wallpaper_height,0)
              x = 0-wallpaper_width
              Repeat
                x = x+wallpaper_width/6
                For xx=x To x+wallpaper_width/13
                  LineXY(xx,0,xx+wallpaper_width,wallpaper_width,RGB($FF,$FF,$00))
                Next xx
              Until x > wallpaper_width
            StopDrawing()
            p = p+1
            ;
          Case "traffic"
            ;
            ; red diagonals on a white background, all monitors
            ;
            StartDrawing(ImageOutput(#i_1))
              DrawingMode(#PB_2DDrawing_Default)
              Box(0,0,wallpaper_width,wallpaper_height,$FFFFFF)
              x = 0-wallpaper_width
              Repeat
                x = x+wallpaper_width/10
                For xx=x To x+wallpaper_width/20
                  LineXY(xx,0,xx+wallpaper_width,wallpaper_width,$0000FF)
                Next xx
              Until x > wallpaper_width
            StopDrawing()
            p = p+1
            ;
          Case "drain"
            ;
            ; drain all color and darken a little, all monitors
            ;
            StartDrawing(ImageOutput(#i_1))
              DrawingMode(#PB_2DDrawing_Default)
              For x = 0 To wallpaper_width-1
                For y = 0 To wallpaper_height-1
                  c = Point(x,y)
                  c = 0.2*Red(c)+0.2*Blue(c)+0.3*Green(c)
                  Plot(x,y,RGB(c,c,c))
                Next y
              Next x
            StopDrawing()
            p = p+1
            ;
          Case "blur"
            ;
            ; GrabImage(#i_1,#i_2,wallpaper_width*0.01+4,wallpaper_height*0.01+4,wallpaper_width*0.99-8,wallpaper_height*0.99-8)
            ; ResizeImage(2,wallpaper_width+2,wallpaper_height+2)
            ;
            CopyImage(#i_1,#i_2)
            StartDrawing(ImageOutput(#i_1))
              DrawingMode(#PB_2DDrawing_Default)
              DrawAlphaImage(ImageID(#i_2),-1,1,32)
              DrawAlphaImage(ImageID(#i_2),-2,-1,64)
              DrawAlphaImage(ImageID(#i_2),2,1,64)
              DrawAlphaImage(ImageID(#i_2),1,-1,32)
            StopDrawing()
            p = p+1
            ;
          Case "dots"
            ;
            ; small pattern of black dots (25%), per monitor
            ;
            For area_n = area_first To area_last
              getdesktopposition(area_n)
              ;
              StartDrawing(ImageOutput(#i_1))
                DrawingMode(#PB_2DDrawing_Default)
                x = 2
                While x < area_width+1
                  y = 2
                  While y < area_height-1
                    Box(area_x+x,area_y+y,2,2,0)
                    y = y+4
                  Wend
                  x = x+4
                Wend
              StopDrawing()
            Next
            p = p+1
            ;
          Case "fade"
            ;
            ; fade to black top to bottom, per monitor
            ;
            For area_n = area_first To area_last
              getdesktopposition(area_n)
              ;
              StartDrawing(ImageOutput(#i_1))
                DrawingMode(#PB_2DDrawing_AlphaBlend)
                For y = 0 To area_height-1
                  LineXY(area_x+0,area_y+y,area_x+area_width-1,area_y+y,y*255/area_height*$1000000)
                Next y
              StopDrawing()
            Next area_n
            p = p+1
            ;
          Case "darken"
            ;
            ; darken the image 25%
            ;
            StartDrawing(ImageOutput(#i_1))
              DrawingMode(#PB_2DDrawing_AlphaBlend)
              Box(0,0,wallpaper_width,wallpaper_height,RGBA(0,0,0,64))
            StopDrawing()
            p = p+1
            ;
          Case "invert"
            ;
            ; make a negative of the image
            ;
            StartDrawing(ImageOutput(#i_1))
              DrawingMode(#PB_2DDrawing_XOr)
              Box(0,0,wallpaper_width,wallpaper_height,RGBA(255,255,255,255))
            StopDrawing()
            p = p+1
            ;
          Case "reverse"
            ;
            ; black text with white shadows
            ;
            fontcolor = $FFFFFF-fontcolor
            p = p+1
            ;
          Case "font"
            ;
            ; select font to use
            ;
            fontname = parameter
            fontsize = Val(x_commandfield(commandline,p+2))
            p = p+3
            ;
          Case "big"
            ;
            ; big background text in white, per monitor
            ;
            ; font name as specified by 'font <fontname> <fontsize>'
            ; font size hardcoded
            ; use for other fontsizes the option 'text'
            ;
            For area_n = area_first To area_last
              getdesktopposition(area_n)
              ;
              t.s = maketext(parameter)
              If CountString(t.s,".") = 3
                t.s = StringField(t.s,4,".")
                If t.s = ""
                  t.s = maketext(parameter)
                EndIf
              EndIf
              LoadFont(1,fontname,area_height*6/9,#PB_Font_Bold|#PB_Font_HighQuality)
              StartDrawing(ImageOutput(#i_1))
                If transparent
                  DrawingMode(#PB_2DDrawing_AlphaBlend)
                Else
                  DrawingMode(#PB_2DDrawing_Transparent)
                EndIf
                DrawingFont(FontID(1))
                DrawText(area_x+area_width/2-TextWidth(t)/2,area_y+area_height/2-TextHeight(t)/2,t,fontcolor+64*$1000000,256*$1000000)
              StopDrawing()
              FreeFont(1)
            Next
            p = p+2
            ;
          Case "text"
            ;
            ; foreground text in 100% with black shadow, per monitor
            ;
            ; font name and size specified by 'font <fontname> <fontsize>'
            ;
            LoadFont(2,fontname,fontsize,#PB_Font_Bold|#PB_Font_HighQuality)
            LoadFont(3,fontname,fontsize/2,#PB_Font_Bold|#PB_Font_HighQuality)
            For area_n = area_first To area_last
              getdesktopposition(area_n)
              t.s = maketext(parameter)
              StartDrawing(ImageOutput(#i_1))
                If transparent
                  DrawingMode(#PB_2DDrawing_AlphaBlend)
                Else
                  DrawingMode(#PB_2DDrawing_Transparent)
                EndIf
                n = CountString(t,"|")+1
                nn = 0
                While nn < n
                  nn = nn+1
                  tt.s = Trim(StringField(t,nn,"|"))
                  If tt.s = ""
                  ElseIf nn = 1
                    DrawingFont(FontID(2))
                    DrawText(area_x+area_width/2-TextWidth(tt)/2+2,area_y+area_height/2-fontsize/2+2,tt,$FFFFFF-fontcolor+16*$1000000,256*$1000000)
                    DrawText(area_x+area_width/2-TextWidth(tt)/2,area_y+area_height/2-fontsize/2,tt,fontcolor+96*$1000000,256*$1000000)
                  Else
                    DrawingFont(FontID(3))
                    DrawText(area_x+area_width/2-TextWidth(tt)/2+2,area_y+area_height/2-fontsize*0.4+fontsize*0.8*nn+2,tt,$FFFFFF-fontcolor+16*$1000000,256*$1000000)
                    DrawText(area_x+area_width/2-TextWidth(tt)/2,area_y+area_height/2-fontsize*0.4+fontsize*0.8*nn,tt,fontcolor+96*$1000000,256*$1000000)
                  EndIf
                Wend
              StopDrawing()
            Next
            FreeFont(2)
            FreeFont(3)
            p = p+2
            ;
          Case "load"
            ;
            ; load the specified image, or the one currently selected in the control panel
            ;
            loadfile(parameter)
            p = p+2
            ;
          Case "frompanel"
            ;
            ; load current wallpaper from control panel
            ;
            x_registry_get(#HKEY_CURRENT_USER,"Control Panel\Desktop","Wallpaper")
            If x_registry_s = "" Or FileSize(x_registry_s) <= 0
            Else
              loadfile(x_registry_s)
            EndIf
            p = p+1
            ;
          Case "pairs"
            ;
            ; set chance for using image pairs from the wallx.lst file
            ;
            pairs = Val(parameter)
            p = p+2
            ;
          Case "keep"
            ;
            keep = #True
            p = p+1
            ;
          Case "random"
            ;
            loadrandom(parameter)
            p = p+2
            ;
          Case "save"
            ;
            ; save the created image under the specified name, all desktops combined
            ;
            wall_filename = parameter
            If wall_filename = "programfolder"
              wall_filename = GetPathPart(ProgramFilename())+"wallx.bmp"
            ElseIf wall_filename = "currentfolder"
              wall_filename = GetCurrentDirectory()+"wallx.bmp"
            ElseIf wall_filename = "tempfolder"
              wall_filename = GetTemporaryDirectory()+"wallx.bmp"
            EndIf
            keep = #True
            p = p+2
            ;
          Case "end"
            ;
            ; end flag, should no longer be required
            ;
            p = p+1
            ;
          Case "resident", "background"
            ;
            ; keep wallx in memory and monitor screen and / or ip changes
            ;
            stayresident = #True
            p = p+1
            ;
          Case "kill"
            ;
            ; send a termination message to any wallx instances running
            ;
            PostMessage_(#HWND_BROADCAST,killmessage_nr,0,0)
            p = p+1
            ;
          Case "renew"
            ;
            ; renew wallpaper every 'n' seconds
            ;
            renew = Val(parameter)
            p = p+2
            ;
          Case "nouser"
            ;
            ; only renew wallpaper if the user was not active for 'n' seconds
            ;
            nouser = Val(parameter)
            p = p+2
            ;
          Default
            ;
            ; unknown command / parameter
            ;
            If silent = #False
              MessageRequester("WallX "+#program_version,"Unrecognized command or missing parameter"+#CRLF$+#CRLF$+command,#PB_MessageRequester_Ok|#MB_ICONERROR)
              command_error = #True
            EndIf
            p = p+1
            ;
      EndSelect
    Until p > command_n Or command = "end" Or command = "help" Or command_error = #True
    ;
    If command_error = #False
      CreateImage(#i_2,wallpaper_width,wallpaper_height)
      For area_n = 0 To desktops_n
        getdesktopposition(area_n)
        GrabImage(#i_1,#i_3,area_x,area_y,area_width,area_height)
        StartDrawing(ImageOutput(#i_2))
          x = area_x+wallpaper_x
          y = area_y+wallpaper_y
          DrawImage(ImageID(#i_3),x,y)
          If x < 0
            DrawImage(ImageID(#i_3),x+wallpaper_width,y)
          EndIf
          If x+area_width > wallpaper_width
            DrawImage(ImageID(#i_3),x-wallpaper_width,y)
          EndIf
          If y < 0
            DrawImage(ImageID(#i_3),x,y+wallpaper_height)
          EndIf
          If y+area_height > wallpaper_height
            DrawImage(ImageID(#i_3),x,y-wallpaper_height)
          EndIf
          If x < 0 And y < 0
            DrawImage(ImageID(#i_3),x+wallpaper_width,y+wallpaper_height)
          EndIf
          If x > wallpaper_width And y > wallpaper_height
            DrawImage(ImageID(#i_3),x-wallpaper_width,y-wallpaper_height)
          EndIf
        StopDrawing()
      Next
      SaveImage(#i_2,wall_filename)
      FreeImage(#i_2)
      ;
      x_registry_set(#HKEY_CURRENT_USER,"Control Panel\Desktop","TileWallPaper",#REG_SZ,0,"1",1)
      ;
      ; wall_filename = "c:\windows\default.bmp"
      ; x_registry_set(#HKEY_CURRENT_USER,"Control Panel\Desktop","TileWallPaper",#REG_SZ,0,"0",1)
      ;
      If keep = #True
        SystemParametersInfo_(#SPI_SETDESKWALLPAPER,0,@wall_filename,#SPIF_UPDATEINIFILE)
        SystemParametersInfo_(#SPI_SETDESKWALLPAPER,0,@wall_filename,#SPIF_SENDWININICHANGE)
      Else
        SystemParametersInfo_(#SPI_SETDESKWALLPAPER,0,@wall_filename,0)
      EndIf
      ;
      If wall_filename = GetTemporaryDirectory()+"wallx.bmp" And keep = #False
        DeleteFile(wall_filename)
      EndIf
    EndIf
    FreeImage(#i_1)
    ;
  EndIf
  ;
EndProcedure

Procedure commandlinetogui()
  Protected command.s, parameter.s, section.i, n.i, transparent.i, reverse.i
  ;
  SetGadgetState(#g_background,#g_background__randomcolour)
  SetGadgetState(#g_effect1_dots,0)
  SetGadgetState(#g_effect1_fade,0)
  SetGadgetState(#g_effect1_darken,0)
  SetGadgetState(#g_effect1_drain,0)
  SetGadgetState(#g_effect1_blur,0)
  SetGadgetState(#g_effect1_invert,0)
  SetGadgetState(#g_big_transparent,0)
  SetGadgetState(#g_big_reverse,0)
  SetGadgetText(#g_big_text,"")
  SetGadgetState(#g_effect2_dots,0)
  SetGadgetState(#g_effect2_fade,0)
  SetGadgetState(#g_effect2_darken,0)
  SetGadgetState(#g_effect2_drain,0)
  SetGadgetState(#g_effect2_blur,0)
  SetGadgetState(#g_effect2_invert,0)
  SetGadgetText(#g_normal_text,"")
  SetGadgetState(#g_normal_transparent,0)
  SetGadgetState(#g_normal_reverse,0)
  SetGadgetState(#g_effect3_dots,0)
  SetGadgetState(#g_effect3_fade,0)
  SetGadgetState(#g_effect3_darken,0)
  SetGadgetState(#g_effect3_drain,0)
  SetGadgetState(#g_effect3_blur,0)
  SetGadgetState(#g_effect3_invert,0)
  SetGadgetText(#g_distort,"")
  SetGadgetText(#g_expand,"")
  SetGadgetText(#g_renew,"")
  SetGadgetText(#g_nouser,"")
  SetGadgetState(#g_keep,0)
  SetGadgetState(#g_resident,0)
  ;
  command_n = x_commandcount(commandline)
  section = 1
  n = 0
  While n < command_n
    n = n+1
    command = x_commandfield(commandline,n)
    parameter = x_commandfield(commandline,n+1)
    Select command
        Case "load"
          SetGadgetState(#g_background,#g_background__file)
          SetGadgetText(#g_background_file,parameter)
          n = n+1
        Case "random"
          SetGadgetState(#g_background,#g_background__path)
          SetGadgetText(#g_background_file,parameter)
          n = n+1
        Case "transparent"
          transparent = #True
        Case "solid"
          transparent = #False
        Case "reverse"
          reverse = 1 - reverse
        Case "big"
          SetGadgetState(#g_big_transparent,transparent)
          SetGadgetState(#g_big_reverse,reverse)
          SetGadgetText(#g_big_text,parameter)
          section = 2
          n = n+1
        Case "text"
          SetGadgetState(#g_normal_transparent,transparent)
          SetGadgetState(#g_normal_reverse,reverse)
          SetGadgetText(#g_normal_text,parameter)
          section = 3
          n = n+1
        Case "red"
          SetGadgetState(#g_background,#g_background__red)
        Case "green"
          SetGadgetState(#g_background,#g_background__green)
        Case "blue"
          SetGadgetState(#g_background,#g_background__blue)
        Case "cyan"
          SetGadgetState(#g_background,#g_background__cyan)
        Case "lime"
          SetGadgetState(#g_background,#g_background__lime)
        Case "pink"
          SetGadgetState(#g_background,#g_background__pink)
        Case "black"
          SetGadgetState(#g_background,#g_background__black)
        Case "white"
          SetGadgetState(#g_background,#g_background__white)
        Case "grey"
          SetGadgetState(#g_background,#g_background__grey)
        Case "traffic"
          SetGadgetState(#g_background,#g_background__traffic)
        Case "base"
          SetGadgetState(#g_background,#g_background__base)
        Case "frame"
          SetGadgetState(#g_background,#g_background__frame)
        Case "distort"
          SetGadgetText(#g_distort,parameter)
          n = n+1
        Case "expand"
          SetGadgetText(#g_expand,parameter)
          n = n+1
        Case "renew"
          SetGadgetText(#g_renew,parameter)
          n = n+1
        Case "nouser"
          SetGadgetText(#g_nouser,parameter)
          n = n+1
        Case "keep"
          SetGadgetState(#g_keep,1)
        Case "resident", "background"
          SetGadgetState(#g_resident,1)
    EndSelect
    Select section
        Case 1
          Select command
              Case "dots"
                SetGadgetState(#g_effect1_dots,1)
              Case "fade"
                SetGadgetState(#g_effect1_fade,1)
              Case "darken"
                SetGadgetState(#g_effect1_darken,1)
              Case "drain"
                SetGadgetState(#g_effect1_drain,1)
              Case "blur"
                SetGadgetState(#g_effect1_blur,1)
              Case "invert"
                SetGadgetState(#g_effect1_invert,1)
          EndSelect
        Case 2
          Select command
              Case "dots"
                SetGadgetState(#g_effect2_dots,1)
              Case "fade"
                SetGadgetState(#g_effect2_fade,1)
              Case "darken"
                SetGadgetState(#g_effect2_darken,1)
              Case "drain"
                SetGadgetState(#g_effect2_drain,1)
              Case "blur"
                SetGadgetState(#g_effect2_blur,1)
              Case "invert"
                SetGadgetState(#g_effect2_invert,1)
          EndSelect
        Case 3
          Select command
              Case "dots"
                SetGadgetState(#g_effect3_dots,1)
              Case "fade"
                SetGadgetState(#g_effect3_fade,1)
              Case "darken"
                SetGadgetState(#g_effect3_darken,1)
              Case "drain"
                SetGadgetState(#g_effect3_drain,1)
              Case "blur"
                SetGadgetState(#g_effect3_blur,1)
              Case "invert"
                SetGadgetState(#g_effect3_invert,1)
          EndSelect
    EndSelect
  Wend
  ;
EndProcedure

Procedure guitocommandline()
  Protected t.s
  ;
  commandline = ""
  ;
  t = GetGadgetText(#g_distort)
  If t > ""
    commandline = commandline+" distort "+Str(Val(t))
  EndIf
  t = GetGadgetText(#g_expand)
  If t > ""
    commandline = commandline+" expand "+Str(Val(t))
  EndIf
  ;
  Select GetGadgetState(#g_background)
      Case #g_background__randomcolour
      Case #g_background__red
        commandline = commandline+" red"
      Case #g_background__green
        commandline = commandline+" green"
      Case #g_background__blue
        commandline = commandline+" blue"
      Case #g_background__cyan
        commandline = commandline+" cyan"
      Case #g_background__lime
        commandline = commandline+" lime"
      Case #g_background__orange
        commandline = commandline+" orange"
      Case #g_background__pink
        commandline = commandline+" pink"
      Case #g_background__black
        commandline = commandline+" black"
      Case #g_background__grey
        commandline = commandline+" grey"
      Case #g_background__white
        commandline = commandline+" white"
      Case #g_background__traffic
        commandline = commandline+" traffic"
      Case #g_background__base
        commandline = commandline+" base"
      Case #g_background__frame
        commandline = commandline+" green frame"
      Case #g_background__file
        commandline = commandline+" load "+#DQUOTE$+GetGadgetText(#g_background_file)+#DQUOTE$
      Case #g_background__path
        t = GetGadgetText(#g_background_file)
        If t = "programfolder"
        ElseIf Right(t,1)="\"
          t = #DQUOTE$+t+#DQUOTE$
        ElseIf x_exist(t)
          t = #DQUOTE$+GetPathPart(t)+#DQUOTE$
        Else
          t = #DQUOTE$+t+"\"+#DQUOTE$
        EndIf
        commandline = commandline+" random "+t
      Case #g_background__programfolder
        commandline = commandline+" random programfolder"
  EndSelect
  ;
  If GetGadgetState(#g_effect1_dots)
    commandline = commandline+" dots"
  EndIf
  If GetGadgetState(#g_effect1_fade)
    commandline = commandline+" fade"
  EndIf
  If GetGadgetState(#g_effect1_darken)
    commandline = commandline+" darken"
  EndIf
  If GetGadgetState(#g_effect1_drain)
    commandline = commandline+" drain"
  EndIf
  If GetGadgetState(#g_effect1_invert)
    commandline = commandline+" invert"
  EndIf
  If GetGadgetState(#g_effect1_blur)
    commandline = commandline+" blur"
  EndIf
  ;
  t = GetGadgetText(#g_big_text)
  If t > ""
    If GetGadgetState(#g_big_transparent)
      commandline = commandline+" transparent"
    EndIf
    If GetGadgetState(#g_big_reverse)
      commandline = commandline+" reverse"
    EndIf
    commandline = commandline+" big "+Chr(34)+t+Chr(34)
  EndIf
  ;
  If GetGadgetState(#g_effect2_dots)
    commandline = commandline+" dots"
  EndIf
  If GetGadgetState(#g_effect2_fade)
    commandline = commandline+" fade"
  EndIf
  If GetGadgetState(#g_effect2_darken)
    commandline = commandline+" darken"
  EndIf
  If GetGadgetState(#g_effect2_drain)
    commandline = commandline+" drain"
  EndIf
  If GetGadgetState(#g_effect2_invert)
    commandline = commandline+" invert"
  EndIf
  If GetGadgetState(#g_effect2_blur)
    commandline = commandline+" blur"
  EndIf
  ;
  t = GetGadgetText(#g_normal_text)
  If t > ""
    If GetGadgetState(#g_normal_transparent)
      commandline = commandline+" transparent"
    ElseIf GetGadgetState(#g_big_transparent)
      commandline = commandline+" solid"
    EndIf
    If GetGadgetState(#g_normal_reverse) <> GetGadgetState(#g_big_reverse)
      commandline = commandline+" reverse"
    EndIf
    commandline = commandline+" text "+Chr(34)+t+Chr(34)
  EndIf
  ;
  If GetGadgetState(#g_effect3_dots)
    commandline = commandline+" dots"
  EndIf
  If GetGadgetState(#g_effect3_fade)
    commandline = commandline+" fade"
  EndIf
  If GetGadgetState(#g_effect3_darken)
    commandline = commandline+" darken"
  EndIf
  If GetGadgetState(#g_effect3_drain)
    commandline = commandline+" drain"
  EndIf
  If GetGadgetState(#g_effect3_invert)
    commandline = commandline+" invert"
  EndIf
  If GetGadgetState(#g_effect3_blur)
    commandline = commandline+" blur"
  EndIf
  ;
  t = GetGadgetText(#g_renew)
  If t > ""
    commandline = commandline+" renew "+Str(Val(t))
  EndIf
  t = GetGadgetText(#g_nouser)
  If t > ""
    commandline = commandline+" nouser "+Str(Val(t))
  EndIf
  ;
  If GetGadgetState(#g_keep)
    commandline = commandline+" keep"
  EndIf
  If GetGadgetState(#g_resident)
    commandline = commandline+" background"
  EndIf
  ;
  commandline = Trim(commandline)
  command_n = x_commandcount(commandline)
  SetGadgetText(#g_commandline,commandline)
  ;
EndProcedure

Procedure main()
  Protected n.i, t.s, file.s, nn.i, f.i, g.i, x.i, y.i, h.i
  Protected wall_current.s, kill_count.i, t_delay.i
  Protected change.i, k.s
  Protected lastinputinfo.LASTINPUTINFO
  Protected old_commandline.s, command.s, parameter.s
  Protected change_counter, monitor.i, old_command.s
  Protected target.s, link.s
  ;
  lastinputinfo\cbSize = SizeOf(lastinputinfo)
  ;
  ; main loop
  ;
  ; commands / parameters can come in five ways
  ;
  ; 1. when run from within the ide
  ; 2. from the command line
  ; 3. from a file wallx.cmd
  ; 4. from an autorun entry
  ; 5. there were none so use default and show gui
  ;
  command_n = 0
  If #codecaddy_compilerun
    ;
    ; 1. from within the IDE
    ;
    ; set up command_test.s for quick testing from withing the IDE
    ; use '' instead of " here, that's easier than using #DQUOTE$ all the time :-)
    ;
    commandline = ""
    ; commandline = "help"
    ; commandline = "dotmark ''TEST''"
    ; commandline = "pink mark XPS710 save programfolder"
    ; commandline = "base"
    ; commandline = "basemark VISTA64 SP3"
    ; commandline = "blue dotmark test"
    ; commandline = "delay 2 base fade text ''BASE IMAGE | TEST | NOT FOR REGULAR USE | ~host~ ~ip~ ''"
    ; commandline = "basemark TEST resident"
    ; commandline = "monitor 0 red monitor 1 blue text ''~desktop~ ~timestamp~'' monitor all drain"
    ; commandline = "monitor 0 red big ~desktop~ dots monitor 1 blue big ~desktop~ fade"
    ; commandline = "blue big ~desktop~ dots text ''TEST | ~host~ ~ip~ '' fade"
    ; commandline = "base blue fade dots"
    ; commandline = "traffic text test fade"
    ; commandline = "help"
    ; commandline = "load c:\software\wallpaper\an_air.jpg"
    ; ommandline = "load c:\software\wallpapers\2h_bamboo.jpg transparent big ~ip~ text ''TEST | ~host~ ~ip~ ''"
    ; commandline = "load c:\software\wallpapers\2h_mountain_lake.jpg dots transparent big ~desktop~ text '' MONITOR ~desktop~ | ~timestamp~'' fade "
    ; commandline = "monitor 0 load c:\software\wallpapers\an_evangelion.jpg monitor 1 load c:\software\wallpapers\an_eureka7_1.jpg monitor all transparent big ~ip~ dots text ''XPS710 | ~host~ ~ip~ '' fade"
    ; commandline = "random c:\software\wallpaper"
    ; commandline = "silent random c:\software\wallpaper transparent mark xps710"
    ; commandline = "traffic desktop 0 red desktop 1 blue desktop all dotmark ~monitor~ save c:\software\wallpaper\test.bmp"
    ; commandline = "traffic drain mark ~monitor~"
    ; commandline = "traffic distort 40 expand 200 random c:\software\wallpaper transparent big ~monitor~ frame save c:\software\wallpaper\test.bmp"
    ; commandline = "random c:\software\wallpaper frame renew 4 resident"
    ; commandline = "dotmark ~USER~ resident"
    ; commandline = "text ''~ip~|~ipall~''"
    ; commandline = "ipallmark test"
    ; commandline = "traffic reverse drain dotmark ~USER~ keep"
    ; commandline = "random g:\wallpapers renew 2 nouser 10 resident"
    ; commandline = "mark test"
    ; commandline = "transparent mark MEDIA4"
    ; commandline = "big ~ip~ fade transparent text ''ADMIN|~host~ ~ip~'' fade"
    ; commandline = "distort 10 expand 100 random g:\wallpapers\ transparent mark ''DEV2'' renew 1 nouser 1 pairs 99 resident"
    ; commandline = "gui"
    ; commandline = "get d:\test.bmp"
    ; commandline = "set d:\test.bmp gui"
    ;
    commandline = Trim(ReplaceString(commandline,"''",#DQUOTE$))
    command_n = x_commandcount(commandline)
    preset = #g_preset__none
    ;
  EndIf
  If command_n = 0
    ;
    ; 2. check for command line parameters
    ;
    command_n = CountProgramParameters()
    n = 0
    While n < command_n
      n = n+1
      t = ProgramParameter()
      If FindString(t," ") > 0
        commandline = commandline+" "+#DQUOTE$+t+#DQUOTE$+" "
      Else
        commandline = commandline+" "+t
      EndIf
    Wend
    commandline = Trim(commandline)
    command_n = x_commandcount(commandline)
    preset = #g_preset__none
    ;
  EndIf
  If command_n = 0
    ;
    ; 3. read configuration from wallx.cmd if one exists
    ;
    file = GetPathPart(ProgramFilename())+"wallx.cmd"
    If FileSize(file)>2
      ReadFile(1,file)
      While Not Eof(1)
        k = Trim(ReadString(1))
        If k > "" And Left(k,1) <> ";"
          commandline = commandline + k
        EndIf
      Wend
      CloseFile(1)
      commandline = Trim(commandline)
      command_n = x_commandcount(commandline)
    EndIf
    preset = #g_preset__none
    ;
  EndIf
  If command_n = 0
    ;
    ; 4. retrieve commandline from an autorun entry in the registry
    ;
    If x_registry_get(#HKEY_CURRENT_USER,"Software\Microsoft\Windows\CurrentVersion\Run","WallX") = 0
      n = Len(x_commandfield(x_registry_s,1,#False))
      commandline = Trim(Mid(x_registry_s,n+1))+" gui"
      command_n = x_commandcount(commandline)
    EndIf
    preset = #g_preset__autorun
    ;
  EndIf
  If command_n = 0
    ;
    ; 5. there wasn't a commandline so use the default one
    ;
    commandline = "distort 10 expand 100 random programfolder fade renew 600 nouser 120 gui"
    ;
    ; corporate users might not like the default 'keep' option
    ;
    ;   If OSVersion() >= #PB_OS_Windows_Vista
    ;     commandline = commandline+" keep"
    ;   EndIf
    ;
    command_n = x_commandcount(commandline)
    preset = #g_preset__default
    ;
  EndIf
  ;
  ; expand combos and handle special one-shot cases
  ;
  old_command = ""
  t = ""
  n = 0
  While n < command_n
    n = n+1
    command = x_commandfield(commandline,n,#False)
    parameter = x_commandfield(commandline,n+1,#True)
    Select command
        Case "gui"
          ;
          gui = #True
          ;
        Case "help"
          ;
          x_littlehelp(" WallX "+#program_version+" - "+#program_copyright+" - "+FormatDate("%DD.%MM.%YYYY",#codecaddy_build_date)+" build "+Str(#codecaddy_build_nr)+" save "+Str(#codecaddy_save_nr),"",p_helptext,#PB_Ascii)
          commandline = ""
          command_n = 0
          t = ""
          ;
        Case "adminmark"
          ;
          ; my regular admin wallpaper
          ;
          t = t+" traffic darken big ~ip~ fade text "+#DQUOTE$+"ADMIN | ~host~ ~ip~"+#DQUOTE$
          ;
        Case "basemark"
          ;
          ; my regular base wallpaper
          ;
          t = t+" base fade text "+#DQUOTE$+" BASE IMAGE | "+parameter+" | NOT FOR REGULAR USE | ~host~ ~ip~"+#DQUOTE$
          n = n+1
          ;
        Case "highmark"
          ;
          ; companion to basemark / adminmark
          ;
          t = t+" big ~ip~ fade text "+#DQUOTE$+parameter+"| ~host~ ~ip~"+#DQUOTE$
          n = n+1
          ;
        Case "lowmark", "mark"
          ;
          ; typical use: on top of normal wallpapers
          ;
          t = t+" transparent big ~ip~ fade text "+#DQUOTE$+parameter+"| ~host~ ~ip~"+#DQUOTE$
          n = n+1
          ;
        Case "darkmark"
          ;
          ; as highmark but more contrast
          ;
          t = t+" fade big ~ip~ darken text "+#DQUOTE$+parameter+"| ~host~ ~ip~"+#DQUOTE$+" darken darken"
          n = n+1
          ;
        Case "dotmark"
          ;
          ; my default settings for images showing one ip address
          ;
          t = t+" big ~ip~ dots text "+#DQUOTE$+parameter+"| ~host~ ~ip~ "+#DQUOTE$+" fade"
          n = n+1
          ;
        Case "ipallmark"
          ;
          ; my regular wallpaper for images showing all ip addresses
          ;
          t = t+" big ~ip~ dots text "+#DQUOTE$+parameter+"| ~host~ ~ipall~ "+#DQUOTE$+" fade"
          n = n+1
          ;
        Case "delay"
          ;
          ; manual one shot delay (eats up windows messages though)
          ;
          t_delay = GetTickCount_()+Val(parameter)*1000
          While GetTickCount_() < t_delay
            Delay(128)
          Wend
          n = n+1
          ;
        Case "get"
          ;
          ; retrieve name / path / file of current wallpaper
          ;
          file = Space(#MAX_PATH+2)
          SystemParametersInfo_(#SPI_GETDESKWALLPAPER,Len(file),@file,0)
          If parameter = "name"
            MessageRequester("WallX "+#program_version,"Current wallpaper is "+#CRLF$+#CRLF$+file,#PB_MessageRequester_Ok)
          ElseIf parameter > ""
            If CopyFile(file,parameter) = 0 And silent = #False
              MessageRequester("WallX "+#program_version,"Could not copy "+#CRLF$+#CRLF$+file+#CRLF$+#CRLF$+"to"+#CRLF$+#CRLF$+parameter,#PB_MessageRequester_Ok|#MB_ICONERROR)
            EndIf
          EndIf
          n = n+1
          ;
        Case "set"
          ;
          ; directly set wallpaper and switch tiling off
          ;
          If x_exist(parameter)
            x_registry_set(#HKEY_CURRENT_USER,"Control Panel\Desktop","TileWallPaper",#REG_SZ,0,"0",0)
            SystemParametersInfo_(#SPI_SETDESKWALLPAPER,0,@parameter,#SPIF_UPDATEINIFILE)
            SystemParametersInfo_(#SPI_SETDESKWALLPAPER,0,@parameter,#SPIF_SENDWININICHANGE)
          Else
            MessageRequester("WallX "+#program_version,"Could not find "+#CRLF$+#CRLF$+parameter,#PB_MessageRequester_Ok|#MB_ICONERROR)
          EndIf
          n = n+1
          ;
        Default
          ;
          If old_command <> "save" And old_command <> "load" And Len(command)> 4 And ( LCase(Right(command,4)) = ".jpg" Or LCase(Right(command,4)) = ".bmp" Or LCase(Right(command,4)) = ".png" )
            ;
            ; v1.70x now allows direct referencing to files, as happens in drag and drop, or for those too lazy to type 'load'
            ; multiple images are spread over all monitors
            ;
            monitor = monitor+1
            If monitor = 1
              t = t+" load "+#DQUOTE$+command+#DQUOTE$+" fade"
            Else
              t = t+" monitor "+Str(monitor)+" load "+#DQUOTE$+command+#DQUOTE$+" fade"
            EndIf
            ;
          Else
            ;
            ; must be some other command that doesn't need processing (yet)
            ;
            t = t+" "+command
            old_command = command
            ;
          EndIf
    EndSelect
    ;
  Wend
  commandline = Trim(t)
  command_n = x_commandcount(commandline)
  ;
  ; if a gui is requested then build it up, otherwise an invisible window suffies
  ;
  If gui = #True
    ;
    ; build up the GUI window
    ;
    h = 408
    w_main_h = OpenWindow(#w_main_nr,10,10,510,h,"WallX "+#program_version+" - "+#program_copyright,#PB_Window_SystemMenu|#PB_Window_ScreenCentered)
    ;
    x = 20
    y = 12
    TextGadget(#g_preset_t,x,y+10,100,16,"Load preset")
    ComboBoxGadget(#g_preset,x+100,y+7,272,22)
    AddGadgetItem(#g_preset,#g_preset__none,"None")
    AddGadgetItem(#g_preset,#g_preset__default,"Default")
    AddGadgetItem(#g_preset,#g_preset__autorun,"Autorun")
    AddGadgetItem(#g_preset,#g_preset__poweruser,"Poweruser")
    AddGadgetItem(#g_preset,#g_preset__pinktimestamp,"Pink Timestamp")
    AddGadgetItem(#g_preset,#g_preset__adminmark,"Adminmark (equivalent to the 'adminmark' command)")
    AddGadgetItem(#g_preset,#g_preset__basemark,"Basemark (equivalent to the 'basemark' command)")
    AddGadgetItem(#g_preset,#g_preset__drainedbase,"Drained Base")
    AddGadgetItem(#g_preset,#g_preset__doubleinvert,"Double Invert")
    AddGadgetItem(#g_preset,#g_preset__loadfile,"Load image from file")
    AddGadgetItem(#g_preset,#g_preset__randomfrompath,"Random image from path")
    AddGadgetItem(#g_preset,#g_preset__randomfromprogramfolder,"Random image from program folder")
    AddGadgetItem(#g_preset,#g_preset__directorscut,"Director's cut (add 'background' and 'keep')")
    AddGadgetItem(#g_preset,#g_preset__autochange,"Random image every 2 seconds (add 'background')")
    AddGadgetItem(#g_preset,#g_preset__frame,"Frame (check wallx.bmp in the temp folder)")
    AddGadgetItem(#g_preset,#g_preset__unwise,"Unwise (all on, very slow)")
    ;
    x = 416
    CheckBoxGadget(#g_auto,x,y+11,45,16,"Auto")
    GadgetToolTip(#g_auto,"Immediately apply any changes")
    ButtonImageGadget(#g_try,x+48,y,32,32,ImageID(#i_eyes_2))
    GadgetToolTip(#g_try,"Apply settings")
    ;
    x = 20
    y = y+35
    h = 220
    FrameGadget(#g_frame,7,y,497,h,"")
    ;
    y = y+18
    TextGadget(#g_background_t,x,y+4,100,16,"1. Background")
    ComboBoxGadget(#g_background,x+100,y,100,22)
    AddGadgetItem(#g_background,#g_background__randomcolour,"Random colour")
    AddGadgetItem(#g_background,#g_background__red,"Red")
    AddGadgetItem(#g_background,#g_background__green,"Green")
    AddGadgetItem(#g_background,#g_background__blue,"Blue")
    AddGadgetItem(#g_background,#g_background__cyan,"Cyan")
    AddGadgetItem(#g_background,#g_background__lime,"Lime")
    AddGadgetItem(#g_background,#g_background__orange,"Orange")
    AddGadgetItem(#g_background,#g_background__pink,"Pink")
    AddGadgetItem(#g_background,#g_background__black,"Black")
    AddGadgetItem(#g_background,#g_background__grey,"Grey")
    AddGadgetItem(#g_background,#g_background__white,"White")
    AddGadgetItem(#g_background,#g_background__traffic,"Traffic")
    AddGadgetItem(#g_background,#g_background__base,"Base")
    AddGadgetItem(#g_background,#g_background__frame,"Frame")
    AddGadgetItem(#g_background,#g_background__file,"Load file")
    AddGadgetItem(#g_background,#g_background__path,"Random from path")
    AddGadgetItem(#g_background,#g_background__programfolder,"From program folder")
    ;
    TextGadget(#g_background_file_t,x+220,y+2,60,18,"File")
    StringGadget(#g_background_file,x+260,y,188,18,"")
    GadgetToolTip(#g_background_file,"Image file or path")
    ButtonGadget(#g_background_browse,x+450,y,20,18,"...")
    y = y+28
    TextGadget(#g_effect1_t,x,y+2,100,16,"2. Effect")
    CheckBoxGadget(#g_effect1_dots,x+100,y+2,60,16,"Dots")
    CheckBoxGadget(#g_effect1_fade,x+160,y+2,60,16,"Fade")
    CheckBoxGadget(#g_effect1_darken,x+220,y+2,60,16,"Darken")
    CheckBoxGadget(#g_effect1_drain,x+290,y+2,60,16,"Drain")
    CheckBoxGadget(#g_effect1_blur,x+350,y+2,60,16,"Blur")
    CheckBoxGadget(#g_effect1_invert,x+410,y+2,60,16,"Invert")
    y = y+30
    TextGadget(#g_big_text_t,x,y+2,100,16,"3. Big text")
    StringGadget(#g_big_text,x+100,y,65,18,"")
    GadgetToolTip(#g_big_text,"Large background text (1 to 3 characters)")
    CheckBoxGadget(#g_big_reverse,x+185,y+2,60,16,"Reverse")
    CheckBoxGadget(#g_big_transparent,x+260,y+2,80,16,"Transparent")
    y = y+28
    TextGadget(#g_effect2_t,x,y+2,100,16,"4. Effect")
    CheckBoxGadget(#g_effect2_dots,x+100,y+2,60,16,"Dots")
    CheckBoxGadget(#g_effect2_fade,x+160,y+2,60,16,"Fade")
    CheckBoxGadget(#g_effect2_darken,x+220,y+2,60,16,"Darken")
    CheckBoxGadget(#g_effect2_drain,x+290,y+2,60,16,"Drain")
    CheckBoxGadget(#g_effect2_blur,x+350,y+2,60,16,"Blur")
    CheckBoxGadget(#g_effect2_invert,x+410,y+2,60,16,"Invert")
    y = y+30
    TextGadget(#g_normal_text_t,x,y+2,100,16,"5. Normal text")
    StringGadget(#g_normal_text,x+100,y,200,18,"")
    GadgetToolTip(#g_normal_text,"Normal text (multiple lines | special codes ~host~ ~ip~ ~monitor~)")
    CheckBoxGadget(#g_normal_reverse,x+320,y+2,60,16,"Reverse")
    CheckBoxGadget(#g_normal_transparent,x+395,y+2,80,16,"Transparent")
    y = y+28
    TextGadget(#g_effect3_t,x,y+2,100,16,"6. Effect")
    CheckBoxGadget(#g_effect3_dots,x+100,y+2,60,16,"Dots")
    CheckBoxGadget(#g_effect3_fade,x+160,y+2,60,16,"Fade")
    CheckBoxGadget(#g_effect3_darken,x+220,y+2,60,16,"Darken")
    CheckBoxGadget(#g_effect3_drain,x+290,y+2,60,16,"Drain")
    CheckBoxGadget(#g_effect3_blur,x+350,y+2,60,16,"Blur")
    CheckBoxGadget(#g_effect3_invert,x+410,y+2,60,16,"Invert")
    y=y+30
    TextGadget(#g_timeandplace_t,x,y+2,100,16,"7. Distort & Renew")
    TextGadget(#g_distort_t,x+100,y+2,50,16,"Distort")
    StringGadget(#g_distort,x+140,y,28,18,"")
    GadgetToolTip(#g_distort,"Maximal aspect distortion in % (default 15%)")
    TextGadget(#g_expand_t,x+180,y+2,50,16,"Expand")
    StringGadget(#g_expand,x+220,y,28,18,"")
    GadgetToolTip(#g_expand,"Maximal image resize in % (default 53%)")
    TextGadget(#g_renew_t,x+260,y+2,50,16,"Renew")
    StringGadget(#g_renew,x+300,y,38,18,"")
    GadgetToolTip(#g_renew,"Renew background time in seconds")
    TextGadget(#g_nouser_t,x+350,y+2,50,16,"Nouser")
    StringGadget(#g_nouser,x+395,y,38,18,"")
    GadgetToolTip(#g_nouser,"Only renew if user is away for n seconds (default 120)")
    ;
    y = y+38
    x = 20
    h = 40
    TextGadget(#g_system_t,x,y+2,100,16,"System")
    CheckBoxGadget(#g_keep,x+100,y+2,60,16,"Keep")
    GadgetToolTip(#g_keep,"Store wallpaper as local temp file and show upon reboot (may be required on some Windows platforms)")
    CheckBoxGadget(#g_resident,x+160,y+2,80,16,"Background")
    GadgetToolTip(#g_resident,"Keep WallX running in the background so it can refresh wallpapers and detect screen or IP changes)")
    y = y+28
    TextGadget(#g_commandline_t,x,y,100,16,"Commandline")
    TextGadget(#g_commandline,x+100,y,374,h,"")
    ;
    y = y+18+h
    x = 265
    ImageGadget(#g_autorun_led,x,y+9,16,16,ImageID(#i_led_green_1))
    x = 290
    ButtonImageGadget(#g_autorun_set,x,y,32,32,ImageID(#i_windows))
    GadgetToolTip(#g_autorun_set,"Create autorun entry in the registry")
    x = x+35
    ButtonImageGadget(#g_autorun_clear,x,y,32,32,ImageID(#i_windows_grey))
    GadgetToolTip(#g_autorun_clear,"Remove autorun entry from the registry")
    x = x+35
    ButtonImageGadget(#g_shortcut,x,y,32,32,ImageID(#i_shortcut))
    GadgetToolTip(#g_shortcut,"Create a shortcut on the desktop")
    x = x+35
    ButtonImageGadget(#g_copy,x,y,32,32,ImageID(#i_copy))
    GadgetToolTip(#g_copy,"Copy commandline to clipboard")
    x = x+35
    ButtonImageGadget(#g_help,x,y,32,32,ImageID(#i_help))
    GadgetToolTip(#g_help,"Show documentation")
    x = x+35
    ButtonImageGadget(#g_exit,x,y,32,32,ImageID(#i_exit))
    GadgetToolTip(#g_exit,"Exit (or close window but keep running if 'background' is set)")
    ;
    ; show autorun entry, parse the commandline and fill appropriate gadgets
    ;
    If x_registry_get(#HKEY_CURRENT_USER,"Software\Microsoft\Windows\CurrentVersion\Run","WallX") = 0
      HideGadget(#g_autorun_led,0)
    Else
      HideGadget(#g_autorun_led,1)
    EndIf
    SetGadgetState(#g_preset,preset)
    SetGadgetText(#g_commandline,commandline)
    commandlinetogui()
    ;
  Else
    ;
    ; open a hidden window to grab messages etc.
    ;
    OpenWindow(#w_main_nr,10,10,100,100," WallX "+#program_version+" - "+#program_copyright,#PB_Window_Invisible)
    ;
  EndIf
  ;
  ; prepare ip adress table
  ;
  checkipadresses()
  checkipadresses()
  ;
  ; find desktop dimensions
  ;
  checkdesktops()
  ;
  ; executecommands commands found
  ;
  If gui = #False
    executecommands()
  EndIf
  ;
  ; stay resident
  ;
  If stayresident = #True Or gui = #True
    ;
    ; note! when debugging: don't 'terminate' the app from within the PB IDE as Windows sometimes gets confused...
    ; when testing 'resident' mode kill wallx by sending it a kill message (executecommands 'wallx kill' from the command line):
    ;
    ;   wallx kill
    ;
    ; terminate all other instances by broadcast kill message to all (including myself)
    ;
    PostMessage_(#HWND_BROADCAST,killmessage_nr,0,0)
    n = 0
    kill_count = 0
    ;
    Repeat
      ;
      ; grab windows events
      ;
      If gui
        event = WaitWindowEvent(128)
      Else
        event = WaitWindowEvent(1024)
      EndIf
      event_window = EventWindow()
      event_gadget = EventGadget()
      event_menu = EventMenu()
      ;
      ; make sure the first kill message (which we send ourselves) doesn't kill us
      ; since pb 5.21 I receive two (?) or in the GUI even 5 (?!?!?) messages which I think is wrong
      ; (but the dev didn't want to look into the matter, and it's a bit of an unconventional method anyway)
      ; so what the heck, if I end up with a third kill message then I'll exit, it's a work around but it works
      ;
      If event = killmessage_nr
        kill_count = kill_count+1
        event = 0
      EndIf
      ;
      ; if there's no event (event = 0) then check for changes otherwise handle windows events
      ;
      If event <> 0
        ;
        ; windows events, user interaction
        ;
        Select event
            Case #PB_Event_Gadget
              Select event_gadget
                  Case #g_preset
                    ;
                    ; load a preset
                    ;
                    Select GetGadgetState(#g_preset)
                        Case #g_preset__none
                          commandline = ""
                          ;
                          ; I decided to not affect keep and resident when changing profile
                          ;
                          ;   SetGadgetState(#g_resident,0)
                          ;   SetGadgetState(#g_keep,0)
                          ;
                        Case #g_preset__autorun
                          If x_registry_get(#HKEY_CURRENT_USER,"Software\Microsoft\Windows\CurrentVersion\Run","WallX") = 0
                            n = Len(x_commandfield(x_registry_s,1,#False))
                            commandline = Trim(Mid(x_registry_s,n+1))
                          Else
                            commandline = ""
                          EndIf
                        Case #g_preset__default
                          commandline = "distort 10 expand 100 random programfolder fade renew 600 nouser 120"
                        Case #g_preset__poweruser
                          commandline = "distort 10 expand 100 random programfolder dots transparent big ~ip~ fade text "+#DQUOTE$+"POWERUSER|~host~ - ~ip~"+#DQUOTE$+" renew 600 nouser 120"
                        Case #g_preset__drainedbase
                          commandline = "base drain transparent big ~ip~ text "+#DQUOTE$+"Drained Base"+#DQUOTE$+" darken"
                        Case #g_preset__doubleinvert
                          commandline = "red transparent reverse big BIG invert solid text "+#DQUOTE$+"Double Invert"+#DQUOTE$
                        Case #g_preset__pinktimestamp
                          commandline = "pink darken transparent big BIG text "+#DQUOTE$+"NORMAL|This background was generated by WallX on ~timestamp~|User ~user~ on ~host~ at ~ip~"+#DQUOTE$+" fade"
                        Case #g_preset__adminmark
                          commandline = "traffic darken big ~ip~ fade text "+#DQUOTE$+"ADMIN | ~host~ ~ip~"+#DQUOTE$
                        Case #g_preset__basemark
                          commandline = "base fade text "+#DQUOTE$+" BASE IMAGE | "+parameter+" | NOT FOR REGULAR USE | ~host~ ~ip~"+#DQUOTE$
                        Case #g_preset__loadfile
                          commandline = "distort 10 expand 100 load "+#DQUOTE$+GetPathPart(ProgramFilename())+"walnut1.jpg"+#DQUOTE$
                        Case #g_preset__randomfrompath
                          commandline = "distort 10 expand 100 random "+#DQUOTE$+GetPathPart(ProgramFilename())+#DQUOTE$
                        Case #g_preset__randomfromprogramfolder
                          commandline = "random programfolder distort 10 expand 100"
                        Case #g_preset__directorscut
                          commandline = "distort 10 expand 100 random "+#DQUOTE$+GetPathPart(ProgramFilename())+#DQUOTE$+" transparent big ~ip~ text "+#DQUOTE$+"NAME|~host~ ~ip~"+#DQUOTE$+" fade darken renew 1800 nouser 300"
                        Case #g_preset__autochange
                          commandline = "random programfolder fade distort 10 expand 100 renew 2 nouser 2"
                        Case #g_preset__frame
                          commandline = "green frame text "+#DQUOTE$+"Monitor ~monitor~|For (multimonitor) testing purposes.|Set 'keep' on, re-arrange your screens, then|check the file wallx.bmp in your temp directory."+#DQUOTE$+" fade blur"
                        Case #g_preset__unwise
                          commandline = "base dots fade drain invert blur darken reverse transparent big * base dots fade drain invert blur darken text "+#DQUOTE$+"|ALL ON aka UNWISE aka VERY SLOW"+#DQUOTE$+" base dots fade drain invert blur darken"
                    EndSelect
                    ;
                    ; corporate users might not like the default 'keep' setting
                    ;
                    ;   If OSVersion() >= #PB_OS_Windows_Vista
                    ;     commandline = commandline+" keep"
                    ;   EndIf
                    ;
                    ; so for now I just retain the keep and resident states, ie. they are not written over by profile changes
                    ;
                    If GetGadgetState(#g_keep) And FindString(commandline,"keep") = 0
                      commandline = commandline+" keep"
                    EndIf
                    If GetGadgetState(#g_resident) And FindString(commandline,"background") = 0 And FindString(commandline,"resident") = 0
                      commandline = commandline+" background"
                    EndIf
                    ;
                    commandlinetogui()
                    ;
                  Case #g_background_browse
                    ;
                    ; browse for a file or folder
                    ;
                    Select GetGadgetState(#g_background)
                        Case #g_background__path
                          file = PathRequester("Select folder","")
                          If file > ""
                            SetGadgetText(#g_background_file,file)
                          EndIf
                        Default
                          file = OpenFileRequester("Select image","","Image (*.JPG *.PNG *.BMP)|*.jpg;*.png;*.bmp|All (*.*)|*.*",0)
                          If file > ""
                            SetGadgetText(#g_background_file,file)
                          EndIf
                    EndSelect
                    ;
                  Case #g_try
                    ;
                    ; execute the generated settings
                    ;
                    executecommands()
                    change = #False
                    ;
                  Case #g_help
                    ;
                    ; show help text
                    ;
                    HideWindow(#w_main_nr,1)
                    x_littlehelp(" WallX "+#program_version+" - "+#program_copyright+" - "+FormatDate("%DD.%MM.%YYYY",#codecaddy_build_date)+" build "+Str(#codecaddy_build_nr)+" save "+Str(#codecaddy_save_nr),"",p_helptext,#PB_Ascii)
                    HideWindow(#w_main_nr,0)
                    ;
                  Case #g_shortcut
                    ;
                    ; create a shortcut on the desktop - I try to be smart and create a (more or less) sensible shortcut name
                    ;
                    If Len(commandline) > 0
                      t = ""
                      n = 0
                      While n < command_n
                        n = n+1
                        command = LCase(x_commandfield(commandline,n,#True))
                        parameter = LCase(x_commandfield(commandline,n+1,#True))
                        Select command
                            Case "text"
                              If Len(parameter) < 30
                                t = t+" "+parameter
                              Else
                                t = t+" "+Left(parameter,27)+"..."
                              EndIf
                              n =n+1
                            Case "load"
                              t = t+" "+GetFilePart(parameter)
                              n = n+1
                            Case "random"
                              If Right(parameter,1) = "\"
                                parameter = x_chop(parameter,0,1)
                              EndIf
                              t = t+" random "+GetFilePart(parameter)
                              n = n+1
                            Case "red", "blue", "green", "pink", "cyan", "lime", "orange", "black", "white", "grey", "traffic", "base", "frame", "renew", "keep", "resident", "background"
                              t = t+" "+command
                            Case "distort", "expand"
                              n = n+1
                        EndSelect
                      Wend
                      If t = ""
                        t = commandline
                      EndIf
                      If Len(t) > 70
                        t = Left(t,67)+"..."
                      EndIf
                      t = "WallX"+t
                      t = ReplaceString(t,"~","")
                      t = ReplaceString(t,":","")
                      t = ReplaceString(t,"\","_")
                      t = ReplaceString(t,"/","_")
                      t = ReplaceString(t,"|"," ")
                      t = ReplaceString(t,"<","_")
                      t = ReplaceString(t,">","_")
                      t = ReplaceString(t,"*","_")
                      t = ReplaceString(t,"?","_")
                      t = ReplaceString(t,#DQUOTE$,"")
                      t = ReplaceString(t,"   "," ")
                      t = ReplaceString(t,"  "," ")
                      target.s = ProgramFilename()
                      link.s = x_getspecialfolderlocation(#CSIDL_DESKTOPDIRECTORY)+Trim(t)+".lnk"
                      x_createshelllink(target,link,commandline,"",GetPathPart(target),target, 0)
                    EndIf
                    ;
                  Case #g_autorun_set
                    ;
                    ; create an autorun entry
                    ;
                    If commandline > ""
                      t = Chr(34)+ProgramFilename()+Chr(34)+" "+commandline
                      x_registry_set(#HKEY_CURRENT_USER,"Software\Microsoft\Windows\CurrentVersion\Run","WallX",#REG_SZ,0,t,1)
                    EndIf
                    ;
                  Case #g_autorun_clear
                    ;
                    ; remove the autorun entry
                    ;
                    x_registry_delete(#HKEY_CURRENT_USER,"Software\Microsoft\Windows\CurrentVersion\Run","WallX")
                    ;
                  Case #g_copy
                    ;
                    ; copy to clipboard
                    ;
                    SetClipboardText("wallx "+commandline)
                    ;
                  Case #g_exit
                    ;
                    ; well... just go now and sin more creatively next time!
                    ;
                    event = #PB_Event_CloseWindow
                    ;
              EndSelect
              If gui
                guitocommandline()
                If commandline <> old_commandline And GetGadgetState(#g_auto)
                  change = #True
                  old_commandline = commandline
                EndIf
                If x_registry_get(#HKEY_CURRENT_USER,"Software\Microsoft\Windows\CurrentVersion\Run","WallX") = 0
                  HideGadget(#g_autorun_led,0)
                Else
                  HideGadget(#g_autorun_led,1)
                EndIf
              EndIf
        EndSelect
        ;
      Else
        ;
        ; this is the old inner loop part of previous versions of wallx, check for changes and if needed update the wallpapar
        ;
        ; check for desktop changes
        ;
        change = change | checkdesktops()
        ;
        ; detect hibernations or other long (20 seconds+) freezes
        ;
        If freeze_counter <> 0 And (GetTickCount_() - freeze_counter) > (20*1000)
          change = change | #True
        EndIf
        freeze_counter = GetTickCount_()
        ;
        ; check for ip changes
        ;
        If checkipadresses() = #True
          change = change | #True
        EndIf
        ;
        ; check for wallpaper changes (user or other app changed wallpaper)
        ;
        wall_current = Space(255)
        SystemParametersInfo_(#SPI_GETDESKWALLPAPER,255,@wall_current,0)
        If OSVersion() >= #PB_OS_Windows_XP And wall_filename <> wall_current
          change = change | #True
        EndIf
        ;
        ; check for periodic renewals when user is not active
        ;
        If renew_counter = 0
          renew_counter = GetTickCount_()
        EndIf
        If renew > 0
          If (GetTickCount_()-renew_counter) > (renew*1000) Or (GetTickCount_()-renew_counter) < 0
            GetLastInputInfo_(@lastinputinfo)
            If (GetTickCount_()-lastinputinfo\dwTime) > (nouser*1000) Or (GetTickCount_()-lastinputinfo\dwTime) < 0 Or nouser = 0
              change = change | #True
            EndIf
          EndIf
        EndIf
        ;
        ;
        ; executecommands if any changes
        ;
        If change
          executecommands()
          change = #False
          renew_counter = GetTickCount_()
        EndIf
        ;
      EndIf
      ;
      If event = #PB_Event_CloseWindow And gui
        If #codecaddy_compilerun
          ;
          ; killing WallX every time I mess with the GUI from the IDE is a bit impractical
          ; so I won't stay resident when ran from the IDE regardless of the 'background' aka 'resident' option
          ;
        ElseIf GetGadgetState(#g_resident)
          ;
          ; actually, when exiting the gui WallX should stay running if the resident option was set, so close the regular window
          ; and reopen the hidden one to handle events
          ;
          CloseWindow(#w_main_nr)
          OpenWindow(#w_main_nr,10,10,100,100," WallX "+#program_version+" - "+#program_copyright,#PB_Window_Invisible)
          event = 0
          kill_count = 0
          gui = #False
        EndIf
      EndIf
      ;
    Until event = #PB_Event_CloseWindow Or ( gui = #False And kill_count > 2 ) Or (gui = #False And command_error = #True)
  EndIf
  ;
  CloseWindow(#w_main_nr)
  ;
EndProcedure

; IDE Options = PureBasic 5.30 (Windows - x86)
; Folding = T+-
; Markers = 750
; EnableUnicode
; EnableThread
; EnableXP
; UseIcon = icons\walnut.ico
; Executable = wallx.exe
; CurrentDirectory = C:\software\purebasic\_projects\
; CompileSourceDirectory
; EnableCompileCount = 3751
; EnableBuildCount = 204
; EnableExeConstant