; wallx98 v1.34x
; pb4.51rc2
;
; *** this is the windows 98 version of wallx, based on the regular wallx98 v1.34x ***
; *** this version will NOT be maintained, only use this on windows 98 ***
; 
#program_name = "WallX98"
#program_version = "v1.34x"
#program_copyright = "c2010 EJN"

EnableExplicit
InitNetwork()
UseJPEGImageDecoder()
Declare init()
Declare main()
init()
main()
End

Procedure history()
  ;
  ; planned
  ;
  ; - nothing :-)
  ;
  ; v1.33
  ;
  ; - added 'renew'
  ; - added 'nouser'
  ;
  ; v1.32
  ;
  ; - bugfix 'silent'
  ; - fixed some typos
  ; - added batch file example for dropping image files
  ;
  ; v1.30
  ;
  ; - fixed a bug in selecting entry from wallx.lst
  ; - adding 'wrap around' step to handle windows' stupid wallpaper wrap
  ; - added 'frame' parameter (good for screenshots and debugging)
  ;
  ; v1.28x
  ;
  ; - 'random' now allows a path 'nearby'
  ;
  ; v1.26x
  ;
  ; - 'big' now bases fontsize on monitor size
  ; - added alerts to report missing files and unrecognized commands
  ; - added 'silent' parameter to silence the new alerts ;-)
  ;
  ; v1.22x
  ;
  ; - new 'random' keyword to load random file(s) from folder
  ; - recognizes wallx.lst file
  ; - transparent mode for superimposed text
  ; - added distort and expand commands
  ; - added transparent command
  ;
  ; v1.18x
  ;
  ; - added support for individual per monitor settings
  ; - improved load command, autodetects multi monitor wallpapers and auto adjusts images
  ;
  ; current
  ;
  ; - upgraded to pb4.40b7
  ; - added registry routine as I 'tiling' to handle multi monitor setup
  ; - changed screen change detection for multi monitor support
  ;
  ; v1.16
  ;
  ; - figured out issues with vista (64) and gave up on it...
  ; - added better support for windows 98
  ; - fixed background on multiple lines of text
  ; - denies background changes by other programs when running resident (might help in vista)
  ;
  ; v1.07
  ;
  ; - restructured command line processing
  ; - improved littlehelp() routine
  ; - added 'real' command line processing (to be included in future x_lib's)
  ; - added reading from a configuration file
  ; - text command now allows empty lines
  ; - real time monitoring enabled
  ; - little 'lazyhelp' viewer included
  ;
  ; v1.00
  ;
  ; - had to turn this into a real program, as it was getting a little unmanageable :-)
  ;
  ; v0.08x
  ;
  ; - ah, something that works!
  ;
EndProcedure

Procedure init()
  ;
  Global helptext.s                                              ; text to show for help function
  Global command_string.s                                        ; test string when ran from within the PB IDE
  Global command_n.i                                             ; number of commands given on the commandline
  Global NewList command.s()                                     ; commands / parameters from the commandline
  Global wall_filename.s = GetTemporaryDirectory()+"wallx.bmp"   ; temporary filename used for creating the background
  Global fontname.s = "Arial"                                    ; default font (name)
  Global fontsize.i = 64                                         ; default font (size)
  Global fontcolor = $FFFFFF                                     ; default font (color)
  Global stayresident.i = #False                                 ; stay alive and monitor IP or screen changes
  Global killmessage.s = "wallx - terminate"                     ; message used to kill wallx instances
  Global killmessage_nr = RegisterWindowMessage_(@killmessage)   ; registered message number for the kill message
  ;
  Global desktops_n.i                                            ; number of desktops (monitors)
  Global wallpaper_x.i, wallpaper_y.i                            ; wallpaper origion (top leftmost screen corner)
  Global wallpaper_width.i, wallpaper_height.i                   ; total desktops width and height
  Global wallpaper_aspect.f
  Global aspect_distort.i = 15                                   ; image may be distorted up to 15% (half that for single screen images)
  Global multi_expand.i = 53                                     ; image may be expanded up to for multi monitor setups 53%
  Global transparent.i = #False                                  ; draw text in transparent mode (default off)
  Global silent.i = #False                                       ; alert on missing files and wrong commands (default on)
  Global renew.i = 0                                             ; refresh wallpaper after n seconds, 0 is no refresh (default 0)
  Global renew_counter.i = 0                                     ; number of ticks since last refresh
  Global nouser.i = 120                                          ; only refresh if there is no user activity (default 2 minutes)
  ;
  Structure desktop
    x.i                                                          ; x coordinate of desktop
    y.i                                                          ; y coordinate of desktop
    width.i                                                      ; width of desktop
    height.i                                                     ; height of desktop
    depth.i                                                      ; colour depth
  EndStructure
  ;
  Structure LASTINPUTINFO                                        ; structure for detection of user activity
    cbSize.l
    dwTime.l
  EndStructure
  ;
  Global Dim desktop.desktop(10)                                 ; create an array for 10 screens, that should do it :-)
  ;
  Global area_selected.i = -1                                    ; selected area aka desktop aka monitor (-1 means all)
  Global area_n.i                                                ; desktop for which output is prepared (mostly used as a loop counter)
  Global area_first.i, area_last.i                               ; first and last desktop to draw on (simplifies per desktop vs. for all code)
  Global area_x.i, area_y.i                                      ; x,y of the area of the big generated wallpaper related to the specified monitor
  Global area_width.i, area_height.i                             ; width / height
  Global area_aspect.f                                           ; aspect ratio
  ;
  Global mode.i = 2                                              ; defines different ways of creating the wallpaper, mode = 2 should work for everything
  DataSection
    helptext:
    IncludeBinary("wallx98.txt")
    Data.b 0, 0
  EndDataSection
  ;
EndProcedure

Procedure littlehelp(title.s,text.s,delta.i=0)
  Protected text_size.i, page_size.i, page_number.i, page_count.i
  Protected p.i, n.i, l.i,  h.i
  Protected width.i, height.i
  Protected w_showhelp.i, g_text.i, g_previous.i, g_next.i, g_done.i, font_nr.i
  Protected Dim page_start.i(10)
  Protected Dim page_size.i(10)
  Protected event.i
  ;
  ; displays a little window with the given text, and allows to browse through that text
  ;
  ; in:   title.s    - window title
  ;       text.s     - multi line text seperated by CRLF's
  ;       delta.i    - decreases page size by 'n' lines to beautify text layout
  ;
  ; note: if text shows up with inconvenient page breaks then try 1 or 2 for delta
  ;       though keep in mind this would only apply to a specific screen resolution,
  ;       things will look different on another system with another screen resolution
  ;
  ExamineDesktops()
  text_size = CountString(text,#CRLF$)+1
  page_size = DesktopHeight(0)/23
  height = page_size*17
  page_size = page_size-delta
  page_count = 1+(text_size-1)/page_size
  width = 500
  ;
  p = 1
  n = 0
  Repeat
    n = n+1
    page_start.i(n) = p
    l = 0
    Repeat
      p = FindString(text,#CRLF$,p+1)
      l = l+1
    Until l >= page_size Or p = 0
    If p > 0
      page_size(n) = p-page_start(n)
      p = p+2
    Else
      page_size(n) = Len(text)-page_start(n)+1
    EndIf
  Until p <= 0
  ;
  font_nr = LoadFont(#PB_Any,"Courier New",9)
  w_showhelp = OpenWindow(#PB_Any,10,10,width+16,height+16,title,#PB_Window_SystemMenu|#PB_Window_ScreenCentered)
  AddKeyboardShortcut(w_showhelp,#PB_Shortcut_Return,1)
  AddKeyboardShortcut(w_showhelp,#PB_Shortcut_Escape,1)
  ;
  g_text = TextGadget(#PB_Any,16,16,width,height-50,"")
  g_previous = ButtonGadget(#PB_Any,width-140,height-12,50,22,"<")
  g_next = ButtonGadget(#PB_Any,width-90,height-12,50,22,">")
  g_done = ButtonGadget(#PB_Any,width-40,height-12,50,22,"Ok")
  SetGadgetFont(g_text,FontID(font_nr))
  ;
  page_number = 1
  SetGadgetText(g_text,Mid(text,page_start(page_number),page_size(page_number)))
  Repeat
    If page_number = 1
      DisableGadget(g_previous,1)
    Else
      DisableGadget(g_previous,0)
    EndIf
    If page_number = page_count
      DisableGadget(g_next,1)
    Else
      DisableGadget(g_next,0)
    EndIf
    event = WaitWindowEvent()
    Select event
    Case #PB_Event_Menu
      event = #PB_Event_CloseWindow
    Case #PB_Event_Gadget
      Select EventGadget()
      Case g_previous
        page_number = page_number-1
      Case g_next
        page_number = page_number+1
      Case g_done
        event = #PB_Event_CloseWindow
      EndSelect
      SetGadgetText(g_text,Mid(text,page_start(page_number),page_size(page_number)))
    EndSelect
  Until event = #PB_Event_CloseWindow
  CloseWindow(w_showhelp)
  FreeFont(font_nr)
  ;
EndProcedure

Procedure.i max(a.l,b.l)
  ;
  ; it's too silly this doesn't exist as a primitive yet in purebasic
  ;
  If a > b
    ProcedureReturn a
  Else
    ProcedureReturn b
  EndIf
EndProcedure

Procedure.i min(a.l,b.l)
  ;
  ; it's too silly this doesn't exist as a primitive yet in purebasic
  ;
  If a < b
    ProcedureReturn a
  Else
    ProcedureReturn b
  EndIf
EndProcedure

Procedure.i setregistry(topkey.i,subkey.s,name.s,type.i,value.q,string.s,create.i)
  Protected handle.i , result.i, retval.i
  ;
  ; *** set / create key / value / string in registry
  ;
  ; in:      topkey.i
  ;          subkey.s
  ;          name.s
  ;          type.i = 0      - see msdn, not all types supported
  ;          value.q         - value to store
  ;          string.s        - string to store
  ;          create.i = 0    - open only existing keys (error out otherwise)
  ;                   = 1    - create key if it didn't exist
  ; retval:  0               - ok
  ;          <>              - error
  ; out:     retval          - as retval
  ;
  ; notes:
  ;
  ; - see msdn for all registry types, not all types supported
  ; - see also x_registry_get(), x_registry_getx(), x_registry_setx(), x_registry_setstring()
  ;
  handle = 0                 ; placeholder for key handle
  result = 0                 ; placeholder for result
  ;
  If create = 0                                                             ; try to open an existing key
    retval = RegOpenKeyEx_(topkey,@subkey,0,#KEY_ALL_ACCESS,@handle)
    If retval = 0                                                         ; key does exist
      retval = RegQueryValueEx_(handle,name,0,0,0,0)                      ; can we open a name?
      If retval <> 0                                                      ; nope, close the key
        RegCloseKey_(@handle)
      EndIf
    EndIf
  Else
    retval = RegCreateKeyEx_(topkey,@subkey,0,0,#REG_OPTION_NON_VOLATILE,#KEY_ALL_ACCESS,0,@handle,@result)
  EndIf
  If retval = 0
    Select type
    Case #REG_DWORD, #REG_DWORD_LITTLE_ENDIAN
      retval = RegSetValueEx_(handle,@name,0,type,@value,4)
    Case #REG_QWORD, #REG_QWORD_LITTLE_ENDIAN
      retval = RegSetValueEx_(handle,@name,0,type,@value,8)
    Case #REG_SZ, #REG_LINK, #REG_EXPAND_SZ
      retval = RegSetValueEx_(handle,@name,0,type,@string,StringByteLength(string))
    Default
      retval = -1
    EndSelect
    RegCloseKey_(handle)
  EndIf
  ProcedureReturn retval
EndProcedure

Procedure.s commandfield(string.s,index.i,stripquotes.i=0)
  Protected l.i, field.i, inside.i, p_start.i, p.i
  ;
  ; *** returns space seperated fields, keeps double quoted sections whole
  ;
  ; in:       string.s                - string to parse
  ;           index.i                 - field to return
  ;           stripquotes.i = #true   - include encompassing quotes in return value
  ; retval:   .s                      - string matching the index number
  ;
  ; a 'command line string' contains multiple sections, of which some are enclosed in parenthesis
  ; this routine splits up and spits out :-) space seperated sections, where spaces in doublequoted
  ; parts are ignored
  ;
  l = Len(string)
  field = 0
  inside = #False
  p_start = 1
  p = 0
  While p < l And field <> index
    p = p+1
    Select Asc(Mid(string,p,1))
    Case ' '                        ; it's a space
      If Not inside                 ; but we're not inside so it counts as a seperator
        If p = p_start              ; we just started so it must be two spaces following eachother
          p_start = p+1             ; next char should be a non-space, otherwise we end up here again
        Else
          field = field+1           ; so we just passed a valid field
          If field <> index         ; if it wasn't the field we were looking for
            p_start = p+1           ; then we'll set the start pointer to the start of the next field
          EndIf
        EndIf
      EndIf
    Case '"'                        ; toggle for doublequoted sections
      inside = 1-inside
    EndSelect
  Wend
  If field <> index And p = l       ; reached the end of the string
    field = field+1
    p = p+1
  EndIf
  If field = index                                               ; we had a match
    If stripquotes <> 0 And Mid(string,p_start,1)=#DQUOTE$       ; optional stripping of doublequotes
      ProcedureReturn Trim(Mid(string,p_start+1,p-p_start-2))
    Else
      ProcedureReturn Mid(string,p_start,p-p_start)              ; no stripping
    EndIf
  Else
    ProcedureReturn ""
  EndIf
EndProcedure

Procedure.i commandcount(string.s)
  Protected l.i, field.i, inside.i, p_start.i, p.i
  ;
  ; *** returns the number of space seperated fields, keeps double quoted sections whole
  ;
  ; in:       string.s                - string to parse
  ; retval:   .s                      - string matching the index number
  ;
  ; a 'command line string' contains multiple sections, of which some are enclosed in parenthesis
  ; this routine counts how many are valid, which can be used with commandfield()
  ;
  l = Len(string)
  field = 0
  inside = #False
  p_start = 1
  p = 0
  While p < l
    p = p+1
    Select Asc(Mid(string,p,1))
    Case ' '                        ; it's a space
      If Not inside                 ; but we're not inside so it counts as a seperator
        If p = p_start              ; we just started so it must be two spaces following eachother
          p_start = p+1             ; next char should be a non-space, otherwise we end up here again
        Else
          field = field+1           ; so we just passed a valid field
          p_start = p+1           ; then we'll set the start pointer to the start of the next field
        EndIf
      EndIf
    Case '"'                        ; toggle for doublequoted sections
      inside = 1-inside
    EndSelect
  Wend
  If p+1 <> p_start
    field = field+1
  EndIf
  ProcedureReturn field
EndProcedure

Procedure.s maketext(text.s)
  Protected ipaddress.i
  ;
  ; *** replaces placeholders with actual information
  ;
  ; replace eventual placeholders such as ~ip~
  ;
  ExamineIPAddresses()
  ipaddress = NextIPAddress()
  text = ReplaceString(text,"~ip~",IPString(ipaddress))
  text = ReplaceString(text,"~host~",Hostname())
  text = ReplaceString(text,"~timestamp~",FormatDate("%dd/%mm/%yy %hh:%ii:%ss",Date()))
  text = ReplaceString(text,"~desktop~",Str(area_n+1))
  text = ReplaceString(text,"~monitor~",Str(area_n+1))
  ProcedureReturn text.s
  ;
EndProcedure

Procedure.i checkdesktops()
  Protected change.i, nn.i
  ;
  ; *** check for desktop changes
  ;
  ; retval: #true    - desktop has changed since last check
  ;         #false   - no change since last check
  ;
  ; get information on all desktops and report if there were changes
  ;
  wallpaper_x = 0
  wallpaper_y = 0
  wallpaper_width = 0
  wallpaper_height = 0
  ;
  change.i = #False
  If ExamineDesktops() <> desktops_n
    change = #True
    desktops_n = ExamineDesktops()
  EndIf
  ;
  wallpaper_x = 0
  wallpaper_y = 0
  wallpaper_width = 0
  wallpaper_height = 0
  ;
  nn = 0
  While nn < desktops_n
    If desktop(nn)\depth <> DesktopDepth(nn)
      _ Or desktop(nn)\x <> DesktopX(nn)
      _ Or desktop(nn)\y <> DesktopY(nn)
      _ Or desktop(nn)\width <> DesktopWidth(nn)
      _ Or desktop(nn)\height <> DesktopHeight(nn)
      desktop(nn)\x = DesktopX(nn)
      desktop(nn)\y = DesktopY(nn)
      desktop(nn)\width = DesktopWidth(nn)
      desktop(nn)\height = DesktopHeight(nn)
      desktop(nn)\depth = DesktopDepth(nn)
      change = #True
    EndIf
    ;
    wallpaper_x = min(wallpaper_x,DesktopX(nn))
    wallpaper_y = min(wallpaper_y,DesktopY(nn))
    wallpaper_width = max(wallpaper_width,DesktopX(nn)+DesktopWidth(nn))
    wallpaper_height = max(wallpaper_height,DesktopY(nn)+DesktopHeight(nn))
    ;
    nn = nn+1
  Wend
  ;
  wallpaper_width = wallpaper_width-wallpaper_x
  wallpaper_height = wallpaper_height-wallpaper_y
  ;
  ProcedureReturn change
EndProcedure

Procedure getdesktopposition(n)
  ;
  ; *** get boundaries (position, size) of monitor to set output to
  ;
  ; ah... shades of the old purebasic usewhatever commands :-)
  ;
  ; there seems to be some inconsistensies inside windows regarding desktop wallpapers
  ; when dealing with multi monitor setups with different screen sizes , this should
  ; fix it
  ;
  If n < 0 Or n >= desktops_n
    n = 0
  EndIf
  If n = -1
    area_x = 0
    area_y = 0
    area_width = wallpaper_width
    area_height = wallpaper_height
  Else
    area_x = desktop(n)\x-wallpaper_x
    area_y = desktop(n)\y-wallpaper_y
    area_width = desktop(n)\width
    area_height = desktop(n)\height
  EndIf
  area_aspect = area_width / area_height
  ;
EndProcedure

Procedure loadfile(file.s)
  Protected image_aspect.f, cut_height.i, cut_width.i, cut_x.i, cut_y.i, retval.i
  Global mode.i
  ;
  ; *** load a wallpaper
  ;
  ; - if the aspect ratio differs too much the image is cropped
  ; - for single screen images only half the distortion of multi screen images is accepted
  ; - automatically detect and apply multi monitor images
  ;
  ; global aspect_distort.i defines the amount of distortion in %
  ; global multi_expend.i defines the amount of expension for multi monitor setups in %
  ;
  If LoadImage(2,file) = 0
    ;
    If silent
    Else
      MessageRequester(#program_name+" "+#program_version,"Missing file:"+#CRLF$+#CRLF$+file,#PB_MessageRequester_Ok)
    EndIf
    ;
  Else
    ;
    wallpaper_aspect = wallpaper_width / wallpaper_height
    image_aspect = ImageWidth(2)/ImageHeight(2)
    ;
    If wallpaper_aspect*115 > image_aspect*(100-aspect_distort)
      _ And wallpaper_aspect*(100-aspect_distort)< image_aspect*115
      _ And ImageWidth(2)*100 > wallpaper_width*(100-multi_expand)
      _ And ImageHeight(2)*100 > wallpaper_height*(100-multi_expand)
      ;
      ; aspect ratio is more or less matching the wallpaper aka combined desktops
      ; and we think there's enough detail so let's build it
      ;
      ; can we stretch it at once? (ie. allow a little distortion but no need to clip things)
      ;
      If wallpaper_aspect*100 > image_aspect*(100-aspect_distort) And wallpaper_aspect*(100-aspect_distort) < image_aspect*100
        ;
        ; aspect rations match sufficiently, stretch to cover all desktops
        ;
        StartDrawing(ImageOutput(1))
          DrawImage(ImageID(2),0,0,wallpaper_width,wallpaper_height)
        StopDrawing()
        ;
      Else
        ;
        ; aspect rations differ too much, crop the image
        ;
        If wallpaper_aspect > image_aspect
          cut_width = ImageWidth(2)
          cut_height = min( ImageHeight(2) , ImageWidth(2) / wallpaper_aspect * 100 / (100-aspect_distort) )
          cut_x = 0
          cut_y = (ImageHeight(2)-cut_height)/2
        Else
          cut_height = ImageHeight(2)
          cut_width = min( ImageWidth(2) , ImageHeight(2) * wallpaper_aspect * 100 / (100-aspect_distort) )
          cut_x = (ImageWidth(2)-cut_width)/2
          cut_y = 0
        EndIf
        StartDrawing(ImageOutput(2))
          GrabDrawingImage(3,cut_x,cut_y,cut_width,cut_height)
        StopDrawing()
        StartDrawing(ImageOutput(1))
          DrawImage(ImageID(3),0,0,wallpaper_width,wallpaper_height)
        StopDrawing()
        FreeImage(3)
        ;
      EndIf
      ;
    Else
      ;
      ; loaded image wasn't suitable for the multi monitor setup, so let's place it on all selected desktops
      ;
      For area_n = area_first To area_last
        getdesktopposition(area_n)
        ;
        If area_aspect*100 > image_aspect*(100-aspect_distort/2) And area_aspect*(100-aspect_distort/2) < image_aspect*100
          ;
          ; aspect rations match sufficiently, stretch to cover selected desktop
          ; note: distortion ratio accepted for single screens is half that of multi monitor setups
          ; (arbitrary decision, I admit :-))
          ;
          StartDrawing(ImageOutput(1))
            DrawImage(ImageID(2),area_x,area_y,area_width,area_height)
          StopDrawing()
          ;
        Else
          ;
          ; aspect rations differ too much, crop the image
          ;
          If wallpaper_aspect > image_aspect
            cut_width = ImageWidth(2)
            cut_height = min( ImageHeight(2) , ImageWidth(2) / area_aspect * 100 / (100-aspect_distort/2) )
            cut_x = 0
            cut_y = (ImageHeight(2)-cut_height)/2
          Else
            cut_height = ImageHeight(2)
            cut_width = min( ImageWidth(2) , ImageHeight(2) * area_aspect * 100 / (100-aspect_distort/2) )
            cut_x = (ImageWidth(2)-cut_width)/2
            cut_y = 0
          EndIf
          StartDrawing(ImageOutput(2))
            GrabDrawingImage(3,cut_x,cut_y,cut_width,cut_height)
          StopDrawing()
          StartDrawing(ImageOutput(1))
            DrawImage(ImageID(3),area_x,area_y,area_width,area_height)
          StopDrawing()
          FreeImage(3)
          ;
        EndIf
        ;
      Next
      ;
    EndIf
    FreeImage(2)
    ;
  EndIf
  ;
EndProcedure

Procedure loadrandom(path.s)
  Protected NewList file.s(), x.s, n.i, file.s, p.i
  ;
  ; *** load one or more wallpapers from the specified folder
  ;
  ; - multi monitor wallpapers will show up with a higher frequency
  ; - this could be compensated by adding pairs in wallx.lst
  ;
  If path = "nearby"
    path = GetPathPart(ProgramFilename())
  EndIf
  ;
  If Right(path,1) <> "\"
    path = path+"\"
  EndIf
  ;
  ; first find a few random files
  ;
  file = path+"wallx.lst"
  If FileSize(file)>2 And Random(100) < 20
    ;
    ; 20% chance on using a pair from the preferred list, if it exists
    ;
    ReadFile(1,file)
    While Not Eof(1)
      x = Trim(ReadString(1))
      If Left(x,1) <> ";" And x > "" And FindString(x,",",1) > 0
        For n = 1 To 8
          AddElement(file())
          file() = StringField(x,n,",")
        Next
      EndIf
    Wend
    CloseFile(1)
    ;
    p = Random(ListSize(file())/8)*8
    For n = 0 To desktops_n-1
      area_first = n
      area_last = n
      SelectElement(file(),p+n)
      loadfile(path+Trim(file()))
    Next
    ;
  Else
    ;
    ; 80% to pick something from the folder
    ;
    If ExamineDirectory(1,path,"*.jpg") > 0
      While NextDirectoryEntry(1)
        If DirectoryEntryType(1) = #PB_DirectoryEntry_File
          AddElement(file())
          file() = DirectoryEntryName(1)
        EndIf
      Wend
      FinishDirectory(1)
    EndIf
    If ListSize(file()) = 0
    Else
      For n = 0 To desktops_n-1
        area_first = n
        area_last = n
        SelectElement(file(),Random(ListSize(file())-1))
        loadfile(path+file())
      Next
    EndIf
    ;
  EndIf
  ;
EndProcedure

Procedure executecommands()
  Protected color.i, x.i, y.i, xx.i, yy.i, n.i, c.i
  Protected t.s, tt.s, nn.i
  ;
  ; *** process list of commands
  ;
  ; create image
  ;
  CreateImage(1,wallpaper_width,wallpaper_height,24)
  StartDrawing(ImageOutput(1))
    FrontColor(RGB(64+Random(64),64+Random(64),64+Random(64)))
    Box(0,0,wallpaper_width,wallpaper_height)
  StopDrawing()
  ;
  ; default desktop stuff
  ;
  area_selected = -1
  area_first = 0
  area_last = desktops_n-1
  getdesktopposition(-1)
  ;
  ; go through all commands in the list
  ;
  ResetList(command.s())
  Repeat
    ;
    If area_selected = -1
      area_first = 0
      area_last = desktops_n-1
    Else
      area_first = area_selected
      area_last = area_selected
    EndIf
    ;
    NextElement(command.s())
    ;
    Select command.s()
    Case "silent"
      ;
      ; skip alerts on missing files and other problems
      ;
      silent = #True
      ;
    Case "distort"
      ;
      ; set maximal distortion for multi monitor images
      ; image is stretched to specified limit, above that it is cropped
      ;
      NextElement(command.s())
      aspect_distort = Val(command.s())
      ;
    Case "expand"
      ;
      ; maximal expansion (resize) of suitable multi monitor wallpapers with a (too) low resolution
      ;
      NextElement(command.s())
      multi_expand = Val(command.s())
      ;
    Case "transparent"
      ;
      ; all subsequent superimposed text will be transparent
      ;
      transparent =  #True
      ;
    Case "desktop", "monitor"
      ;
      ; selected desktop aka monitor to send output to, 'all' for all
      ;
      NextElement(command.s())
      If command.s() = "all"
        area_selected = -1
        area_first = 0
        area_last = desktops_n-1
      Else
        area_selected = Val(command.s())
        area_first = area_selected
        area_last = area_selected
      EndIf
      ;
      getdesktopposition(area_selected)
      ;
    Case "frame"
      ;
      For area_n = 0 To desktops_n
        getdesktopposition(area_n)
        StartDrawing(ImageOutput(1))
          For x = area_x To area_x+area_width-4 Step 4
            FrontColor(RGB($FF,$FF,$FF))
            Box(x,area_y,2,2)
            Box(x,area_y+area_height-2,2,2)
            FrontColor(RGB($00,$00,$00))
            Box(x+2,area_y,2,2)
            Box(x+2,area_y+area_height-2,2,2)
          Next
          For y = area_y To area_y+area_height-4 Step 4
            FrontColor(RGB($FF,$FF,$FF))
            Box(area_x,y,2,2)
            Box(area_x+area_width-2,y,2,2)
            FrontColor(RGB($00,$00,$00))
            Box(area_x,y+2,2,2)
            Box(area_x+area_width-2,y+2,2,2)
          Next
        StopDrawing()
      Next
      ;
    Case "red" , "green" , "blue" , "pink" , "lime" , "black" , "white" , "grey", "brown", "cyan"
      ;
      ; one colour full-screen, per monitor
      ;
      For area_n = area_first To area_last
        getdesktopposition(area_n)
        ;
        StartDrawing(ImageOutput(1))
          DrawingMode(#PB_2DDrawing_Default)
          Select command.s()
          Case "red"
            FrontColor(RGB($7F,$00,$00))         ; 50% red
          Case "green"
            FrontColor(RGB($00,$7F,$00))         ; 50% green
          Case "blue"
            FrontColor(RGB($00,$00,$7F))         ; 50% blue
          Case "black"
            FrontColor(0)                        ; full black
          Case "white"
            FrontColor($FFFFFF)                  ; full white
          Case "grey"
            FrontColor($3F3F3F)                  ; 25% grey
          Case "cyan"
            FrontColor(RGB($00,$FF,$FF))         ; typical cyan
          Case "brown"
            FrontColor(RGB($80,$40,$00))         ; typical brown
          Case "pink"
            FrontColor(RGB($E0,$20,$60))         ; an awful pink :-)
          Case "lime"
            FrontColor(RGB($A0,$F0,$00))         ; another awful colour :-)
          EndSelect
          Box(area_x,area_y,area_width,area_height)
        StopDrawing()
      Next
      ;
    Case "color"
      ;
      ; use spedified colour, per monitor
      ;
      NextElement(command())
      t = command.s()
      If Len(t) = 7
        t = Right(t,6)
      EndIf
      If Len(t) = 6
        color = RGB(Val("$"+Mid(t,1,2)),Val("$"+Mid(t,3,2)),Val("$"+Mid(t,5,2)))
        For area_n = area_first To area_last
          getdesktopposition(area_n)
          ;
          StartDrawing(ImageOutput(1))
            DrawingMode(#PB_2DDrawing_Default)
            FrontColor(color)
            Box(area_x,area_y,area_width,area_height)
          StopDrawing()
        Next
      EndIf
      ;
    Case "base"
      ;
      ; yellow diagonals on black background, all monitors
      ;
      StartDrawing(ImageOutput(1))
        DrawingMode(#PB_2DDrawing_Default)
        Box(0,0,wallpaper_width,wallpaper_height,0)
        x = 0-wallpaper_width
        Repeat
          x = x+wallpaper_width/6
          For xx=x To x+wallpaper_width/13
            LineXY(xx,0,xx+wallpaper_width,wallpaper_width,RGB($FF,$FF,$00))
          Next xx
        Until x > wallpaper_width
      StopDrawing()
      ;
    Case "traffic"
      ;
      ; red diagonals on a white background, all monitors
      ;
      StartDrawing(ImageOutput(1))
        DrawingMode(#PB_2DDrawing_Default)
        Box(0,0,wallpaper_width,wallpaper_height,$FFFFFF)
        x = 0-wallpaper_width
        Repeat
          x = x+wallpaper_width/10
          For xx=x To x+wallpaper_width/20
            LineXY(xx,0,xx+wallpaper_width,wallpaper_width,$0000FF)
          Next xx
        Until x > wallpaper_width
      StopDrawing()
      ;
    Case "drain"
      ;
      ; drain all color and darken a little, all monitors
      ;
      StartDrawing(ImageOutput(1))
        DrawingMode(#PB_2DDrawing_Default)
        For x = 0 To wallpaper_width-1
          For y = 0 To wallpaper_height-1
            c = Point(x,y)
            c = 0.2*Red(c)+0.2*Blue(c)+0.3*Green(c)
            Plot(x,y,RGB(c,c,c))
          Next y
        Next x
      StopDrawing()
      ;
    Case "dots"
      ;
      ; small pattern of black dots (25%), per monitor
      ;
      For area_n = area_first To area_last
        getdesktopposition(area_n)
        ;
        StartDrawing(ImageOutput(1))
          DrawingMode(#PB_2DDrawing_Default)
          x = 2
          While x < area_width+1
            y = 2
            While y < area_height-1
              Box(area_x+x,area_y+y,2,2,0)
              y = y+4
            Wend
            x = x+4
          Wend
        StopDrawing()
      Next
      ;
    Case "fade"
      ;
      ; fade to black top to bottom, per monitor
      ;
      For area_n = area_first To area_last
        getdesktopposition(area_n)
        ;
        StartDrawing(ImageOutput(1))
          DrawingMode(#PB_2DDrawing_AlphaBlend)
          For y = 0 To area_height-1
            LineXY(area_x+0,area_y+y,area_x+area_width-1,area_y+y,y*255/area_height*$1000000)
          Next y
        StopDrawing()
      Next area_n
      ;
    Case "reverse"
      ;
      ; black text with white shadows
      ;
      fontcolor = fontcolor-$FFFFFF
      ;
    Case "font"
      ;
      ; select font to use
      ;
      NextElement(command.s())
      fontname = command.s()
      NextElement(command.s())
      fontsize = Val(command.s())
      ;
    Case "big"
      ;
      ; big background text in white, per monitor
      ;
      ; font name as specified by 'font <fontname> <fontsize>'
      ; font size hardcoded
      ; use for other fontsizes the option 'text'
      ;
      NextElement(command.s())
      For area_n = area_first To area_last
        getdesktopposition(area_n)
        ;
        t.s = maketext(command.s())
        t.s = StringField(t.s,4,".")
        If t.s = ""
          t.s = maketext(command.s())
        EndIf
        LoadFont(1,fontname,area_height*6/9,#PB_Font_Bold|#PB_Font_HighQuality)
        StartDrawing(ImageOutput(1))
          If transparent
            DrawingMode(#PB_2DDrawing_AlphaBlend)
          Else
            DrawingMode(#PB_2DDrawing_Transparent)
          EndIf
          DrawingFont(FontID(1))
          DrawText(area_x+area_width/2-TextWidth(t)/2,area_y+area_height/2-TextHeight(t)/2,t,fontcolor+64*$1000000,256*$1000000)
        StopDrawing()
        FreeFont(1)
      Next
      ;
    Case "text"
      ;
      ; foreground text in 100% with black shadow, per monitor
      ;
      ; font name and size specified by 'font <fontname> <fontsize>'
      ;
      LoadFont(2,fontname,fontsize,#PB_Font_Bold|#PB_Font_HighQuality)
      LoadFont(3,fontname,fontsize/2,#PB_Font_Bold|#PB_Font_HighQuality)
      NextElement(command.s())
      For area_n = area_first To area_last
        getdesktopposition(area_n)
        ;
        t.s = maketext(command.s())
        StartDrawing(ImageOutput(1))
          If transparent
            DrawingMode(#PB_2DDrawing_AlphaBlend)
          Else
            DrawingMode(#PB_2DDrawing_Transparent)
          EndIf
          n = CountString(t,"|")+1
          nn = 0
          While nn < n
            nn = nn+1
            tt.s = Trim(StringField(t,nn,"|"))
            If tt.s = ""
            ElseIf nn = 1
              DrawingFont(FontID(2))
              DrawText(area_x+area_width/2-TextWidth(tt)/2+2,area_y+area_height/2-fontsize/2+2,tt,$FFFFFF-fontcolor+16*$1000000,256*$1000000)
              DrawText(area_x+area_width/2-TextWidth(tt)/2,area_y+area_height/2-fontsize/2,tt,fontcolor+96*$1000000,256*$1000000)
            Else
              DrawingFont(FontID(3))
              DrawText(area_x+area_width/2-TextWidth(tt)/2+2,area_y+area_height/2-fontsize*0.4+fontsize*0.8*nn+2,tt,$FFFFFF-fontcolor+16*$1000000,256*$1000000)
              DrawText(area_x+area_width/2-TextWidth(tt)/2,area_y+area_height/2-fontsize*0.4+fontsize*0.8*nn,tt,fontcolor+96*$1000000,256*$1000000)
            EndIf
          Wend
        StopDrawing()
      Next
      FreeFont(2)
      FreeFont(3)
      ;
    Case "load"
      ;
      ; load the specified image
      ;
      NextElement(command.s())
      loadfile(command.s())
      ;
    Case "random"
      ;
      NextElement(command.s())
      loadrandom(command.s())
      ;
    Case "save"
      ;
      ; save the created image under the specified name, all desktops combined
      ;
      NextElement(command.s())
      wall_filename = command.s()
      If wall_filename = "nearby"
        wall_filename = GetPathPart(ProgramFilename())+"\wallx.bmp"
      EndIf
      ;
    Case "end"
      ;
      ; end flag
      ;
    Case "resident"
      ;
      ; keep wallx in memory and monitor screen and / or ip changes
      ;
      stayresident = #True
      ;
    Case "kill"
      ;
      ; send a termination message to any wallx instances running
      ;
      PostMessage_(#HWND_BROADCAST,killmessage_nr,0,0)
      ;
    Case "renew"
      ;
      ; renew wallpaper every 'n' seconds
      ;
      NextElement(command.s())
      renew = Val(command.s())
      ;
    Case "nouser"
      ;
      ; only renew wallpaper if the user was not active for 'n' seconds
      ;
      NextElement(command.s())
      nouser = Val(command.s())
      ;
    Default
      ;
      ; unknown command / parameter
      ;
      If silent = #False
        MessageRequester(#program_name+" "+#program_version,"Unrecognized command: "+#CRLF$+#CRLF$+command(),#PB_MessageRequester_Ok)
      EndIf
      ;
    EndSelect
  Until command.s() = "end" Or command.s() = "help"
  ;
  If command.s() <> "help"
    CreateImage(2,wallpaper_width,wallpaper_height)
    For area_n = 0 To desktops_n
      getdesktopposition(area_n)
      GrabImage(1,3,area_x,area_y,area_width,area_height)
      StartDrawing(ImageOutput(2))
        x = area_x+wallpaper_x
        y = area_y+wallpaper_y
        DrawImage(ImageID(3),x,y)
        If x < 0
          DrawImage(ImageID(3),x+wallpaper_width,y)
        EndIf
        If x+area_width > wallpaper_width
          DrawImage(ImageID(3),x-wallpaper_width,y)
        EndIf
        If y < 0
          DrawImage(ImageID(3),x,y+wallpaper_height)
        EndIf
        If y+area_height > wallpaper_height
          DrawImage(ImageID(3),x,y-wallpaper_height)
        EndIf
        If x < 0 And y < 0
          DrawImage(ImageID(3),x+wallpaper_width,y+wallpaper_height)
        EndIf
        If x > wallpaper_width And y > wallpaper_height
          DrawImage(ImageID(3),x-wallpaper_width,y-wallpaper_height)
        EndIf
      StopDrawing()
    Next
    SaveImage(2,wall_filename)
    FreeImage(2)
    ;
    setregistry(#HKEY_CURRENT_USER,"Control Panel\Desktop","TileWallPaper",#REG_SZ,0,"1",1)
    SystemParametersInfo_(#SPI_SETDESKWALLPAPER,0,@wall_filename,#SPIF_SENDWININICHANGE)
    If wall_filename = GetTemporaryDirectory()+"wallx.bmp"
      DeleteFile(wall_filename)
    EndIf
  EndIf
  FreeImage(1)
  ;
EndProcedure

Procedure main()
  Protected n.i, t.s, event.i, file.s, nn.i
  Protected ipaddress.i, oldipaddress.i
  Protected wall_current.s, kill_passed.i, t_delay.i
  Protected change.i, x.s
  Protected lastinputinfo.LASTINPUTINFO
  lastinputinfo\cbSize = SizeOf(lastinputinfo)
  ;
  ; main loop
  ;
  ; commands can come in three ways
  ;
  ; 1. from command_test if non-empty and run inside the IDE
  ; 2. from the command line parameters (either specified inside the IDE or in real life)
  ; 3. from a file wallx.cfg if 1 or 2 do not apply
  ;
  command_n = 0
  If #codecaddy_compilerun
    ;
    ; set up command_test.s for quick testing from withing the IDE
    ; use '' instead of " here, that's easier than using #DQUOTE$ all the time :-)
    ;
    ; command_string = "blue fade font Arial 100 text CLIENT|~host~-~ip~"
    ; command_string = "help"
    ; command_string = "mark ''TEST''"
    ; command_string = "pink mark XPS710 save nearby"
    ; command_string = "base"
    ; command_string = "basemark VISTA64 SP3"
    ; command_string = "blue mark test"
    ; command_string = "delay 2 base fade text ''BASE IMAGE | TEST | NOT FOR REGULAR USE | ~host~ ~ip~ ''"
    ; command_string = "basemark TEST resident"
    ; command_string = "monitor 0 red monitor 1 blue text ''~desktop~ ~timestamp~'' monitor all drain"
    ; command_string = "monitor 0 red big ~desktop~ dots monitor 1 blue big ~desktop~ fade"
    ; command_string = "blue big ~desktop~ dots text ''TEST | ~host~ ~ip~ '' fade"
    ; command_string = "base blue fade dots"
    ; command_string = "traffic text test fade"
    ; command_string = "help"
    ; command_string = "load c:\software\wallpaper\an_air.jpg"
    ; command_string = "load c:\software\wallpaper\2h_bamboo.jpg transparent big ~ip~ text ''TEST | ~host~ ~ip~ ''"
    ; command_string = "load c:\software\wallpaper\2h_mountain_lake.jpg dots transparent big ~desktop~ text '' MONITOR ~desktop~ | ~timestamp~'' fade "
    ; command_string = "monitor 0 load c:\software\wallpaper\an_evangelion.jpg monitor 1 load c:\software\wallpaper\an_eureka7_1.jpg monitor all transparent big ~ip~ dots text ''XPS710 | ~host~ ~ip~ '' fade"
    ; command_string = "random c:\software\wallpaper"
    ; command_string = "silent random c:\software\wallpaper transparent mark xps710"
    ; command_string = "traffic desktop 0 red desktop 1 blue desktop all mark ~monitor~ save c:\software\wallpaper\test.bmp"
    ; command_string = "traffic drain mark ~monitor~"
    ; command_string = "traffic distort 40 expand 200 random c:\software\wallpaper transparent big ~monitor~ frame save c:\software\wallpaper\test.bmp"
    command_string = "random c:\software\wallpaper frame renew 4 resident"
    ; command_string = "help"
    ;
    command_string = ReplaceString(command_string,"''",#DQUOTE$)
    command_n = commandcount(command_string)
    n = 0
    While n < command_n
      n = n+1
      AddElement(command())
      command.s() = commandfield(command_string,n,1)
    Wend
    ;
  EndIf
  If command_n = 0
    ;
    ; use command line parameters
    ;
    command_n = CountProgramParameters()
    n = 0
    While n < command_n
      n = n+1
      AddElement(command())
      command.s() = ProgramParameter()
    Wend
    ;
  EndIf
  If command_n = 0
    ;
    ; read configuration from wallx.cmd
    ;
    file = GetPathPart(ProgramFilename())+"wallx.cmd"
    If FileSize(file)>2
      ReadFile(1,file)
      While Not Eof(1)
        x = Trim(ReadString(1))
        If x > "" And Left(x,1) <> ";"
          command_string = command_string+" "+x
        EndIf
      Wend
      CloseFile(1)
      command_n = commandcount(command_string)
      n = 0
      While n < command_n
        n = n+1
        AddElement(command())
        command.s() = commandfield(command_string,n,1)
      Wend
    EndIf
  EndIf
  ;
  ; open a hidden window to grab messages etc.
  ;
  OpenWindow(1,10,10,100,100,#program_name+" "+#program_version,#PB_Window_Invisible)
  ;
  ResetList(command())
  NextElement(command())
  If command_n = 0 Or ( command_n = 1 And ( command.s() = "help" Or command.s() = "/?" ) )
    ;
    ; no parameters, or the request to show the help information
    ;
    Restore helptext
    Read.s helptext
    littlehelp(#program_name+" "+#program_version+" "+#program_copyright+" "+FormatDate("%DD.%MM.%YY",#codecaddy_build_date)+" build "+Str(#codecaddy_build_nr)+" save "+Str(#codecaddy_save_nr),helptext)
    ;
  Else
    ;
    ; first expand eventual combos and executecommands / strip eventual one time commands
    ;
    ResetList(command.s())
    While NextElement(command.s())
      Select command()
      Case "mark"
        ;
        ; my regular wallpaper for images
        ;
        If NextElement(command.s())
          t = command()
          PreviousElement(command.s())
          command.s() = "big"
          NextElement(command.s())
          command.s() = "~ip~"
          AddElement(command.s())
          command.s() = "dots"
          AddElement(command.s())
          command.s() = "text"
          AddElement(command.s())
          command.s() = t + "| ~host~ ~ip~ "
          AddElement(command.s())
          command.s() = "fade"
        EndIf
        ;
      Case "basemark"
        ;
        ; my regular base wallpaper
        ;
        If NextElement(command.s())
          t = command()
          PreviousElement(command.s())
          command.s() = "base"
          NextElement(command.s())
          command.s() = "fade"
          AddElement(command.s())
          command.s() = "text"
          AddElement(command.s())
          command.s() = "BASE IMAGE | "+t+" | NOT FOR REGULAR USE | ~host~ ~ip~"
          t_delay = GetTickCount_()+2*1024
        EndIf
        ;
      Case "delay"
        ;
        ; manual one shot delay (eats up windows messages though)
        ;
        If DeleteElement(command.s())
          If NextElement(command.s())
            t_delay = GetTickCount_()+Val(command.s())*1000
            While GetTickCount_() < t_delay
              WaitWindowEvent(128)
            Wend
          EndIf
        EndIf
      EndSelect
      ;
    Wend
    ;
    ; create ending item
    ;
    AddElement(command.s())
    command.s() = "end"
    ;
    ; find desktop dimensions
    ;
    checkdesktops()
    ;
    ; executecommands commands found
    ;
    executecommands()
    ;
    ; stay resident
    ;
    If stayresident = #True
      ;
      ; note when debugging: don't 'kill' the app as windows get confused...
      ; when testing 'resident' mode kill wallx by sending it a kill message (executecommands wallx kill from the command line)
      ;
      ; store old IP address
      ;
      ExamineIPAddresses()
      oldipaddress = NextIPAddress()
      ;
      ; broadcast kill message to kill other instances
      ;
      PostMessage_(#HWND_BROADCAST,killmessage_nr,0,0)
      n = 0
      kill_passed = #False
      ;
      Repeat
        event = WaitWindowEvent(1024)
        ;
        ; make sure the first kill message (which we send ourselves) doesn't kill us
        ;
        If event = killmessage_nr And kill_passed = #False
          kill_passed = #True
          event = 0
        EndIf
        ;
        ; if there's no event (event = 0) then it's time for a check on changes
        ;
        If event = 0
          ;
          ; check for desktop changes
          ;
          change = #False
          change = checkdesktops()
          ;
          ; check for ip changes
          ;
          ExamineIPAddresses()
          ipaddress = NextIPAddress()
          If ipaddress <> oldipaddress
            change = #True
            oldipaddress = ipaddress
          EndIf
          ;
          ; check for wallpaper changes
          ;
          wall_current = Space(255)
          SystemParametersInfo_(#SPI_GETDESKWALLPAPER,255,@wall_current,0)
          If OSVersion() >= #PB_OS_Windows_XP And wall_filename <> wall_current
            change = #True
          EndIf
          ;
          ; check for periodic renewals when user is not active
          ;
          If renew > 0
            If renew_counter = 0
              renew_counter = GetTickCount_()
            EndIf
            If (GetTickCount_()-renew_counter) > (renew*1000) Or (GetTickCount_()-renew_counter) < 0
              ;
              ; windows xp version: 
              ;
              ;   GetLastInputInfo_(@lastinputinfo)
              ;   If (GetTickCount_()-lastinputinfo\dwTime) > (nouser*1000) Or (GetTickCount_()-lastinputinfo\dwTime) < 0 Or nouser = 0
              ;     renew_counter = GetTickCount_()
              ;     change = #True
              ;   EndIf
              ;
              ; windows 98 version:
              ;
              renew_counter = GetTickCount_()
              change = #True
              ;
            EndIf
          EndIf
          ;
          ; executecommands if any changes
          ;
          If change
            executecommands()
          EndIf
          ;
        EndIf
      Until event = #PB_Event_CloseWindow Or event = killmessage_nr
    EndIf
  EndIf
  ;
  CloseWindow(1)
  ;
EndProcedure

; IDE Options = PureBasic 4.51 RC 2 (Windows - x86)
; CursorPosition = 7
; Folding = Sg--
; Markers = 1068,1181,1372
; UseIcon = icons\walnut.ico
; Executable = wallx98.exe
; CurrentDirectory = C:\software\purebasic\_projects\
; EnableCompileCount = 2171
; EnableBuildCount = 103
; EnableExeConstant